/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   alertqueue.h
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

#ifndef ALERTQUEUE_H_
#define ALERTQUEUE_H_

#include "xtypes.h"

#define ALERT_QUEUE_BASE_PATH "etc/alertd/facilities/"

typedef struct TAlertQueue
{
  char *QueuePath;
  char *QueueDatPath;
  char *ExecPath;
  char *ExecArgs;
  char *TermSeq;
  ULONG Count;
  ULONG FlushCount;
  ULONG FlushTimeInc;
  time_t NextFlushTime;
  int (*FlushMethod)(struct TAlertQueue *);
} TAlertQueue, *PAlertQueue;

TAlertQueue *AlertQueue_New(void);

void AlertQueue_Delete(PAlertQueue);

void AlertQueue_Clear(PAlertQueue);

int AlertQueue_Init(char *, PAlertQueue);

int AlertQueue_Add(PAlertRes, PAlertSrc, time_t, PAlertQueue);
#define AlertQueue_Touch(T, Q) AlertQueue_Add(NULL, NULL, T, Q)

int AlertQueue_FlushPopen(PAlertQueue);

#endif
