/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   fac.h
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

#ifndef FAC_H_
#define FAC_H_

#include "xtypes.h"
#include "alertqueue.h"
#include "alertres.h"
#include "alertsrc.h"

/* bug: put these somewhere else */
#define MAX_PATHLEN 1024
#define MAX_CMDLINE 1024

typedef struct TFacHandle
{
  int (*FacCall)(ULONG, time_t, PAlertRes, PAlertSrc, struct TFacHandle *);
  PAlertQueue AlertQueue;
} TFacHandle, *PFacHandle;

typedef int (*PfnFacCall)(ULONG, time_t, PAlertRes, PAlertSrc, PFacHandle);

int Fac_NfrLog(ULONG, time_t, PAlertRes, PAlertSrc, PFacHandle);

int Fac_Ack(ULONG, time_t, PAlertRes, PAlertSrc, PFacHandle);

int Fac_Console(ULONG, time_t, PAlertRes, PAlertSrc, PFacHandle);

int Fac_SysLog(ULONG, time_t, PAlertRes, PAlertSrc, PFacHandle);

int Fac_Generic(ULONG, time_t, PAlertRes, PAlertSrc, PFacHandle);

#endif
