/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   valertest.c
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

#include "sys-include.h"
#include "libnfr.h"
#include "nfr_res.h"

int main(int argc, char **argv)
{
  int i = 0;
  ULONG Alerts[] = { NFR_ERR_AGAIN, NFR_ERR_FACCESS, NFR_ERR_EOFUNEXPECTED, 
		     NFR_ERR_EOF, NFR_ERR_FNOEXIST, NFR_ERR_FEXISTS,
		     NFR_ERR_FORK, NFR_ERR_UNDEFINED, NFR_ERR_NOT_IMPLEMENTED,
		     NFR_ERR_TIMEOUT };

  int stime = 1;
  int asize = 0;
  int cycles = -1;
  char *Inserts[6] = { "vaSTR1","vaSTR2","vaSTR3","vaSTR4","vaSTR5", NULL };

  if (argc > 1)
    stime = atoi(argv[1]);
  if (argc > 2)
    cycles = atoi(argv[2]);

  asize = sizeof(Alerts)/sizeof(ULONG);
  printf("%d alerts in cycle\n", asize);
  while(cycles)
    {
      if(cycles > 0)
	cycles--;
      i = 0;
      while (i < asize)
	{
	  printf("sending 0x%.8lX\n", Alerts[i]);
	  VAlert_Args_GenerateEx(__FILE__, __LINE__, 
				 NFR_SRC_ALERTD_TEST, Alerts[i], Inserts);
	  sleep(stime);
	  i++;
	}
    }
  exit(0);
}
