/*
	Copyright(C) 1997 Network Flight Recorder, Inc.
	All rights reserved.

	Use and distribution of this software and its source code
	are governed by the terms and conditions of the
	Network Flight Recorder Software License ("LICENSE.TXT")

By Mark Sienkiewicz / NFR

*/

#include <sys-include.h>

#include "allocaters.h"
#include "array.h"
#include "cf.h"
#include "counter.h"
#include "vsch.h"
#include "../../lib/back/query.h"
#include "everything.h"

#include "nfr_res.h"

extern char *new_alert_text;

extern int debug;
extern FILE *debugfp;

static char *new_alert_name;
static char *over_alert_name;

static char * build_alert_string(void *pp, struct axis_map *am)
{
int x,n;
static char b[1000];
char b1[1000];
unsigned char *p = pp;

b[0]=0;
for (x=0; x<am->r.num_fields; x++)
	{
	vsch_print_type(b1,p+am->r.f[x].offset,am->r.f[x].type,am->r.f[x].size);
	n = strlen(am->r.f[x].label);
	if (strlen(b)+n+2 > sizeof(b)-5)
		{
		strcat(b,"...");
		break;
		}
	strcat(b,am->r.f[x].label);
	strcat(b,":");
	strcat(b,b1);
	strcat(b," ");
	}
return b;
}

toss_new_cell_alert(void *p, struct axis_map *am)
{
char *b = build_alert_string(p, am);
int x;
if (debug >= 2)
	fprintf(debugfp,"Generating new cell alert! name -%s- string -%s-\n",
		new_alert_name, b);
x=UsrAlert_Args_Generate("histogram_recorder", new_alert_name, b, NULL);
if (debug >= 2)
	fprintf(debugfp,"return code %d\n",x);
}


toss_too_large_alert(void *p, struct axis_map *am)
{
char *b = build_alert_string(p, am);
int x;
if (debug >= 2)
	fprintf(debugfp,"Generating cell big alert! name -%s- string -%s-\n",
		over_alert_name, b);
x=UsrAlert_Args_Generate("histogram_recorder", over_alert_name, b, NULL);
if (debug >= 2)
	fprintf(debugfp,"return code %d\n",x);
}

char *
calc_alert_name(char *config_file_name, char *which)
{
int n = 1 + strlen(config_file_name) + 1 + strlen(which) + sizeof("_alert");
char *s, *alert_name;

alert_name = malloc(n);
if (!alert_name)
	abort();
/* strcpy(alert_name,"_"); */
/* strcat(alert_name,config_file_name); */

strcpy(alert_name,config_file_name);

s=strrchr(alert_name,'.');
if (s)
	*s=0;
while (s=strchr(alert_name,'/'))
	*s = '_';
strcat(alert_name,which);
strcat(alert_name,"_alert");
return alert_name;
}


calc_alert_names(char *config_file_name)
{
new_alert_name = calc_alert_name(config_file_name,"_new");
over_alert_name = calc_alert_name(config_file_name,"_over");
}
