/*
        Copyright(C) 1997 Network Flight Recorder, Inc.  
        All rights reserved.

        Use and distribution of this software and its source code
        are governed by the terms and conditions of the
        Network Flight Recorder Software License ("LICENSE.TXT")

By Mark Sienkiewicz / NFR

*/

#include "sys-include.h"
#include "array.h"

main()
{
struct array *a[10],*b;
char s[100],s1[100],s2[100],s3[100];
int x;
for (x=0; x<10; x++)
	{
	a[x]=array_create(0);
	printf("array %d at %x\n",x,a[x]);
	}
while (printf(">"),gets(s))
	{
	switch ( sscanf(s,"%s%s%s",s1,s2,s3) )
		{
	case 0:
		exit(0);
	case 1:
		show_it(a[atoi(s1)]);
		break;	
	case 2:
		show_elem(a[atoi(s1)], s2);
		break;
	case 3:
		set_elem(a[atoi(s1)],s2, s3);
		break;
		}
	array_dump_performance(stdout);
	}
}

show_elem(struct array * a, char *subscript)
{
array_node n;
char b[100],b2[100];
void *p;
int bs,b2s;
if (array_find(a, &n, subscript, strlen(subscript), 0, 0,
	array_binary_cmp) != array_ok)
	{
	printf("no such element\n");
	return;
	}
if (array_get(n, &p,&bs,
		b2, sizeof(b2),&b2s) != array_ok)
	printf("array error! ");
memcpy(b,p,bs);
b[bs]=0;
b2[b2s]=0;
printf("element is at %x\n",n);
printf("-%s- %d  -%s- %d\n",b,bs,b2,b2s);
}

set_elem(struct array * a, char *subscript, char *data)
{
array_node n;
switch (array_find(a, &n, subscript, strlen(subscript), 1, 0,array_binary_cmp))
	{
case array_ok: printf("ok\n"); break;
case array_new: printf("new element\n"); break;
default:
	printf("error creating element\n");
	return;
	}
printf("element is at address %x\n",n);
if (array_set(n, data, strlen(data),0) != array_ok)
	printf("array error! ");
else
	printf("array element set\n");
}


show_it(struct array *a)
{
struct array_scan *sc;
struct array_node *n;
char b[100],b2[100];
int bs,b2s;
void *p;
sc=array_start_scan(a);
while (n=array_scan(sc))
	{
	if (array_get(n, &p,&bs,
			b2, sizeof(b2),&b2s) != array_ok)
		printf("array error! ");
	memcpy(b,p,bs);
	b[bs]=0;
	b2[b2s]=0;
	printf("-%s- %d  -%s- %d\n",b,bs,b2,b2s);
	}
}

