/*
        Copyright(C) 1997 Network Flight Recorder, Inc.  
        All rights reserved.

        Use and distribution of this software and its source code
        are governed by the terms and conditions of the
        Network Flight Recorder Software License ("LICENSE.TXT")

By Mark Sienkiewicz / NFR

*/



int debug = 1;

#define ENDIAN_CHAR 'l'

#include "sys-include.h"


#include "allocaters.h"
#include "array.h"
#include "cf.h"
#include "counter.h"
#include "vsch.h"
#include "../../lib/back/query.h"
#include "everything.h"
#include "cgiutils.h"
#include "home.h"
#include "mapping.h"


extern int use_time_as_axis;

struct everything the_histogram = { 0 } ;

struct second_query
	{
	query_match_t	query;
	enum vsch_type	vsch;
	char *name;
	} *second_query;
int second_count;
struct axis_map * am = &the_histogram.axis_map;

PCf cgi_args;
PCf config;

int match_record(struct vsch_buf *);

main( int argc, char **argv )
{
time_t file_min_time, file_max_time;
int x,y,res;
void *p; 
counter data[2];
char *b,b1[100],*s;
int w;
int count;
query_match_t   q;
struct query_types *types;
time_t min_time = 0, max_time = 0;
int use_time=0;
int q_type;
int cpdown;
char * config_file_name;
int mode;
int nuke_value, nuke_col;
int suppress_mapping = 0;
char *recorder_name;

fprintf(stderr,"begin histogram query\n");
CgiGoHome();
Cgi_Debug(argc,argv);

system("pwd >&2");

	cgi_args=Cf_New(0);
	Cgi_QueryToCf(cgi_args);

	b=Cf_GetVal("mode",cgi_args);
	if (!b)
		b="text";
	switch (*b)
		{
	case 't':	/* text */
		printf("content-type: text/plain\n\n");
		mode = 1;
		break;
	case 'e':	/* excel */
		printf("content-type: application/x-excel\n\n");
		mode = 2;
		break;
	case 'h':	/* html */
		printf("content-type: text/html\n\n");
		mode = 3;
		break;
	case 'b':	/* bar */
		printf("content-type: text/plain\n\n");
		mode=4;
		break;
	case 'p':	/* pie */
		printf("content-type: text/plain\n\n");
		mode=5;
		break;
	case 's':	/* scatter */
		printf("content-type: text/plain\n\n");
		mode=6;
		break;
	default:
		printf("bogus mode: %s\n",b);
		mode=1;
		}


	recorder_name=config_file_name=Cf_GetVal("recorder_name",cgi_args);
	if (! config_file_name)
		{
		printf("no recorder_name\n");
		exit(1);
		}
	config_file_name = a_strcat(config_file_name,".cfg");
	/* bug: memory leaking here; just a drop */
	config_file_name = a_strcat("packages/",config_file_name);

	histogram_init(config_file_name, &the_histogram, & config);

	query_load_types();

	b=Cf_GetVal("query_type",cgi_args);
	if (!b)
		{
		printf("error: no query type \n");
		exit(1);
		}

	switch (b[0])
		{
	case '1':
	case '2':
	case '3':
		q_type=b[0]&3;
		break;
	case 'g':
		printf("no general query yet\n");
		exit(1);
	default:
		printf("bogus query type\n");
		exit(1);
		}
	/*
	* first, make an array to hold the queries for secondary types.
	* This array contains 1 element for each secondary type that
	* we are actually querying on.  Note special handling for
	* min_time and max_time, since they are not in the histogram.
	*
	* second_query will be the array of queries.  Yes, it allocates
	* the max memory it could possibly need.  No big deal.
	*/
	for (count=1,types=query_secondary_types; types->name; types++,count++)
		;
	second_query=calloc(count,sizeof(struct second_query));
	if (!second_query)
		nomem();
	/*
	* Loop over the secondary types.  count will be our loop counter.
	* second_count will be how many secondary types we actually have
	* queries for.
	*
	* replace the gets() with something suitable.
	*
	* For regular types, search the list of axes for one that has
	* the secondary type we are looking for.  If not present, we
	* can just quit right now because it will never match.
	*
	* Compile the query and stash relevant information in second_query[]
	* for use when comparing the data.
	*/
	for (count=0, second_count=0; 
		query_secondary_types[count].name; count++)
		{
		b=Cf_GetVal(query_secondary_types[count].name,cgi_args);
		if (b) while (isspace(*b)) b++;
		if (b && b[0])
	   	    {
			{
			for (x=0; x<am->r.num_fields; x++)
				if (strcmp(am->r.f[x].secondary_type,
				    query_secondary_types[count].name) == 0
			   	   )
					goto secondary_ok;
			printf("no axis has that type; nothing can match\n");
			exit(0);
secondary_ok:
			second_query[second_count].query=
			    query_compile(query_secondary_types[count].type,b);
			if (!second_query[second_count].query)
				bad_query("secondary type ",
					query_secondary_types[count].name);
			second_query[second_count].vsch=
				query_secondary_types[count].type;
			second_query[second_count].name=
				query_secondary_types[count].name;
			second_count++;
fprintf(stderr,"secondary - %s\n",b);
query_debug_printer(second_query[second_count-1].query,
		second_query[second_count-1].vsch);
			}
		    }
		}

	b=Cf_GetVal("min_time",cgi_args);
	if (b)
		{
		min_time = atoi(b);
		use_time |= 1;
		}

	b=Cf_GetVal("max_time",cgi_args);
	if (b)
		{
		max_time = atoi(b);
		use_time |= 2;
		}

fprintf(stderr,"min time %d, max_time %d, use_time %d\n",
	min_time, max_time, use_time);


	b=Cf_GetVal("nukepercent",cgi_args);
	if (b)
		nuke_value=atoi(b);
	else
		nuke_value=0;

	nuke_col=0;

	if (the_histogram.axis_map.use_data)
		{
		b=Cf_GetVal("nuke_count",cgi_args);
		if (b)
			nuke_col=1;
		}

	/*
	* adjust time range, if necessary.  If only one limit given,
	* make them both the same.
	*/
	switch (use_time)
		{
	case 0:	/* don't use time */
		break;
	case 1:	/* use min, don't use max */
		max_time= 0x7fffffff;	/* bug: hw dependent */
		break;
	case 2: /* use max, don't use min */
		min_time=0;
		break;
	case 3:	/* specified both already */
		break;
		}
	
	/*
	* next, compile primary types and link them to the axis map
	*
	* Each primary type can only be associated with one axis.
	* Find that axis.  Compile the query for the type of
	* that axis and stash it in the axis_map for use when
	* comparing the data.
	*
	* warn of inconsistencies.
	*/
	for (types = query_primary_types; types->name; types++)
		{
		b=Cf_GetVal(types->name,cgi_args);
		if (b) while (isspace(*b)) b++;
		if (b && b[0])
			{
			count=0;
			for (x=0; x<am->r.num_fields; x++)
				{
				if (strcmp(types->name,am->r.f[x].primary_type)==0)
					{
					if (am->r.f[x].type == types->type)
						{
						am->primary_type_query[x]=
						   query_compile(
							am->r.f[x].type,b);
						if (!am->primary_type_query[x])
							bad_query(
							"primary type",am->r.
							f[x].primary_type);
						count++;
						}
					else
			printf("type in cfg file is wrong representation\n");
					}
				}
			if (count == 0)
				{
				printf("no axis types match; nothing can match\n");
				exit(0);
				}
			if (count != 1)
				printf("%d axes with same type!\n",count);
			}
		}

	/*
	* next, compile the specific query for each axis, if any
	*/
	count=0;
	for (x=0; x<am->r.num_fields; x++)
		{
		sprintf(b1,"column_%d",x);
		b=Cf_GetVal(b1,cgi_args);
		if (!b)
			{ /* BUBGUG: compat with incomplete GUI changes */
			sprintf(b1,"axis_%d",x);
			b = Cf_GetVal(b1,cgi_args);
			}
		if (b)
			{
			am->axis_query[x] = query_compile(am->r.f[x].type,b);
			if (!am->axis_query[x])
				{
				char b[50];
				sprintf(b,"column %d",x+1);
				bad_query(b,"");
				}
			}
		}


	/*
	* label the diminished axes in the axis map, if necessary
	*/
	if (q_type == 1)
		{
		for (x=0; x<am->r.num_fields; x++)
			{
			sprintf(b1,"collapse_%d",x+1);
			b=Cf_GetVal(b1,cgi_args);
			if (b && !strcmp(b,"on"))
				am->r.f[x].diminished = 1;
			}
		}

	if (b=Cf_GetVal("time_checkbox",cgi_args))
		{
		if (strcmp(b,"on") == 0)
			use_time_as_axis = 1;
		}




	if (use_time_as_axis)
		{
		int x;
		if (am->r.num_fields + 1 >= MAX_AXES)
			abort();	/* 20 axes!?!? bug: better error */
		for (x=am->r.num_fields; x>0; x--)
			{
			am->r.f[x] = am->r.f[x-1];
			am->primary_type_query[x]=
				am->primary_type_query[x-1];
			am->axis_query[x]=
				am->axis_query[x-1];
			am->array_compare_fn[x]=
				am->array_compare_fn[x-1];
			}
	
		am->r.f[0].type = VSCH_TIME_T;
		am->r.f[0].size = sizeof(int);
		am->r.f[0].primary_type="time_t";
		am->r.f[0].secondary_type="time_t";
		am->r.f[0].label="Time";
		am->r.f[0].diminished=0;
		am->r.f[0].printwidth=25;
		am->r.f[0].mapping=(void *)0;
		am->primary_type_query[0]=0;
		am->axis_query[0]=0;
		am->array_compare_fn[0]=0;
		am->r.num_fields++;
		}


        b=Cf_GetVal("suppress_mapping",cgi_args);
        if (b && b[0])
                suppress_mapping = 1;

        /* load the type mapping */
        for (x=0; x<am->r.num_fields; x++)
                {
                am->r.f[x].mapping = mapping_open(am->r.f[x].type);
                if ((! suppress_mapping) && ( ! am->r.f[x].diminished ))
                        {
                        mapping_load(am->r.f[x].mapping,  "packages",
                                recorder_name, am->r.f[x].primary_type);
                        mapping_load(am->r.f[x].mapping, "etc/maps",
                                "", am->r.f[x].primary_type );
                        mapping_load(am->r.f[x].mapping,  "packages",
                                recorder_name, am->r.f[x].secondary_type);
                        mapping_load(am->r.f[x].mapping,  "etc/maps",
                                "", am->r.f[x].secondary_type);
                        }
                }


	set_axis_map_compare_function(am);

	/*
	* now start scanning files
	*/

	if (use_time)
		{
		the_histogram.all_time.min_time = min_time;
		the_histogram.all_time.max_time = max_time;
		}
	else
		{
		the_histogram.all_time.min_time = 0;
		the_histogram.all_time.max_time = 0x7fffffff;
		}

	switch (q_type)
		{
	case 2:
		abort();	/* bug: not implemented yet */
		break;
	case 1:
		if (! have_current)
			{
			printf("querying current histogram, but not keeping current histogram\n");
			/* bug: needs better reporting */
			abort();
			}
		/*
		* note we are reading the running histogram, but for
		* queries, was alway use the all_time element of
		* the_histogram.
		*/
		read_histogram_archive(&the_histogram.all_time,
			my_recorder_name,"data",the_histogram.all_time.min_time,
			the_histogram.all_time.max_time,match_record);
		read_histogram_file(&the_histogram.all_time,
			current_name, 1, match_record);
		read_histogram_file(&the_histogram.all_time,
			previous_name, 1, match_record);
		print_histogram(&the_histogram.all_time,mode,nuke_value,
			nuke_col);
		break;
	case 3:
		if (! have_all_time)
			{
			printf("querying all_time histogram, but not keeping all_time histogram\n");
			/* bug: needs better reporting */
			abort();
			}
		read_histogram_file(&the_histogram.all_time,
			all_time_name, 0, match_record);
		print_histogram(&the_histogram.all_time,mode,nuke_value,
			nuke_col);
		break;
		}


fprintf(stderr,"end histogram query\n");
array_dump_performance(stderr);
exit(0);
}


/*
* return true if record matches
*/
match_record(struct vsch_buf *buffer)
{
int x,y;
void *p;
int match_count=0;

for (x=0; x < am->r.num_fields; x++)
	{
	p = buffer->buffer + am->r.f[x].offset ;
	if (query_compare(am->primary_type_query[x], p, am->r.f[x].type,
			am->r.f[x].size))
		match_count++;
	if (query_compare(am->axis_query[x], p, am->r.f[x].type,
			am->r.f[x].size))
		match_count++;
	}

if (match_count != (am->r.num_fields + am->r.num_fields))
	{
	return 0;
	}

/*
* If you want to query on data values, do it here with
* data[0] and data[1].
*/

/*
* for each query on a secondary type,
*	try matching it against all the axes
*
* an axis matches if it has the same secondary type AND the secondary
* type query criteria are met.
* 
* We can use == to compare the char * values in 
*	 if (second_query[y].name == am->secondary_type[x])
* because both are pointers to the same string.  All the type
* name strings point at the same string because of the code
* in query_load_types();
*/
match_count=0;
if (second_count)
    for (y=0; second_query[y].query; y++)
	{
	    for (x=0; x < am->r.num_fields; x++)
		{
		if (second_query[y].name == am->r.f[x].secondary_type)
			if (query_compare(second_query[y].query,
			    buffer->buffer + am->r.f[x].offset,
			    second_query[y].vsch, am->r.f[x].size)
			   )
				{
				match_count++;
				break;
				}
		}
	}
/*
* if we matched one for each secondary type queried, we got
* a match.  Having matched this file, we can go on to
* the next one.
*/
if (match_count != second_count)
	{
	return 0;
	}
return 1;
}


bad_query(char *s, char *t)
{
printf("Error:\nBad query in %s %s\n",s,t);
exit(1);
}
