/*
        Copyright(C) 1997 Network Flight Recorder, Inc.
        All rights reserved.

        Use and distribution of this software and its source code
        are governed by the terms and conditions of the
        Network Flight Recorder Software License ("LICENSE.TXT")

By Mark Sienkiewicz / NFR

*/

#include "sys-include.h"

#include "counter.h"
#include "vsch.h"
#include "cf.h"
#include "list.h"


decode_record( struct columns *thislist, void *buffer, int remaining )
{
int x;
int i;
counter c;
unsigned char *p = buffer;
char buf[100];

/*
walk through the buffer printing each field
*/

#define BUFFER_USE(size) remaining -= size; if (remaining < 0) { printf("\nbuffer underflow\n"); abort(); }
	
BUFFER_USE(sizeof(int))
memcpy(&thislist->time,p,sizeof(int));
p += sizeof(int);

for (x=0; x<thislist->r.num_fields; x++)
	{
	switch (thislist->r.f[x].type)
		{
	case VSCH_COUNTER:
		thislist->c[x].offset = p;
		BUFFER_USE(vsch_size(VSCH_COUNTER))
		p += vsch_size(VSCH_COUNTER);
		break;
	case VSCH_INT:
	case VSCH_TIME_T:
		thislist->c[x].offset = p;
		BUFFER_USE(vsch_size(VSCH_INT))
		p += vsch_size(VSCH_INT);
		break;
	case VSCH_IP:
		thislist->c[x].offset = p;
		BUFFER_USE(4);
		p += 4;
		break;
	case VSCH_ETHERMAC:
		thislist->c[x].offset = p;
		BUFFER_USE(6);
		p += 6;
		break;
	case VSCH_STR:
	case VSCH_BLOB:
		BUFFER_USE(sizeof(int));
		memcpy(&i,p,sizeof(int));
		p += sizeof(int);
		thislist->r.f[x].size = i;
		thislist->c[x].offset = p;
		BUFFER_USE(i);
		p += i;
		break;
	default:
		fprintf(stderr,"unknown type %d\n",thislist->r.f[x].type);
		abort();
		}
	}
}

