/*
        Copyright(C) 1997 Network Flight Recorder, Inc.
        All rights reserved.

        Use and distribution of this software and its source code
        are governed by the terms and conditions of the
        Network Flight Recorder Software License ("LICENSE.TXT")

By Mark Sienkiewicz / NFR

*/


#include "sys-include.h"

#include "counter.h"
#include "vsch.h"
#include "cf.h"
#include "list.h"
#include "archive.h"

struct columns *thislist;

extern void *read_record_buffer;


static Archive *data_file;


extern int archive_debug;

main(int argc,char **argv)
{
int x,type, timestamp;
PCf conf;
if (!argv[1])
	abort();

archive_debug=0;

if ( (! (conf=Cf_New(0)) )
        || Cf_Read(argv[1],conf) )
        {
        perror(argv[1]);
        exit(1);
        }

thislist = load_conf(conf);


data_file = (void *)0;

for (;;)
	{
	if (!intDecode(stdin,&type))
		goto out;
	switch (type)
		{
	case 1:		/* type 1 is the pseudo-type for dynamic schemas */
		x=read_record(stdin, & thislist->r, 0);
		if (x <= 0)
			goto out;
		memcpy(&timestamp, read_record_buffer, sizeof(int));
if (x == 0)
	abort();
		if (!data_file)
			{ char *s; 
			s=strrchr(argv[1],'.'); 
			if (s) *s=0;
			s=strchr(argv[1],'/');
			if (!s)
				{
				fprintf(stderr,"need to use package model\n");
				abort();
				}
			s++;
			data_file = archive_openwrite(s, "data", timestamp, "");
			if (!data_file)
				{
				perror("open archive");
				abort();
				}
			}
		if (archive_write(data_file,x, read_record_buffer, 
			timestamp, "") < 0)
			perror("archive_write");
		break;
	case 57007: /* timestamp schema - see schemas/Schemas/timestamp.sch */
		/*
		* we don't need timestamps, but we have to flush
		* them out of the stream.
		* It contains a single int with a time in it.
		*/
		intDecode(stdin,&type);
		/*
		* Make sure to flush the data files once in a while, though.
		*/
		if (data_file) archive_flush(data_file);
		break;
	default:
		fprintf(stderr,"received bogus schema type: %d\n",type);
		exit(1);
		}
	}
out:
if (data_file) archive_close(data_file);
}

