/*
        Copyright(C) 1997 Network Flight Recorder, Inc.
        All rights reserved.

        Use and distribution of this software and its source code
        are governed by the terms and conditions of the
        Network Flight Recorder Software License ("LICENSE.TXT")

By Mark Sienkiewicz / NFR

*/

#include "sys-include.h"

#include "counter.h"
#include "vsch.h"
#include "cf.h"
#include "list.h"

/*
* bug: you have to refit this a bit to make it handle different
* endian-ness of the input streams or the archive file
*/

struct columns *thislist;

/*
* this is a buffer that accumulates the record as it arrives.
* it gets bigger as necessary.
*/
int record_size = 0;
int this_record_size = 0;
void *buffer = (void *)0;

main(int argc,char **argv)
{
int x,type;
PCf conf;
if (!argv[1])
        abort();

if ( (! (conf=Cf_New(0)) )
        || Cf_Read(argv[1],conf) )
        {
        perror(argv[1]);
        exit(1);
        }

thislist = load_conf(conf);

open_archive();

while (get_archive())
	{
	decode_record(thislist, buffer, this_record_size);
	print_record();
	}

close_archive();
}

FILE *archive;

open_archive()
{
archive=fopen("archive","r");
if (!archive)
	{ perror("archive"); abort(); }
}

close_archive()
{
}

get_archive()
{
int x;
if (fread(&x,1,sizeof(int),archive) != sizeof(int))
	return 0;
if (x > record_size)
	{
	record_size = x;
	buffer=realloc(buffer,record_size);
	if (! buffer)
		return 0;
	}
this_record_size = x;
if (fread(buffer,1,x,archive) != x)
	return 0;
return 1;
}
