/*
        Copyright(C) 1997 Network Flight Recorder, Inc.
        All rights reserved.

        Use and distribution of this software and its source code
        are governed by the terms and conditions of the
        Network Flight Recorder Software License ("LICENSE.TXT")

By Mark Sienkiewicz / NFR

*/


#include "sys-include.h"
int debug = 1;


/*
* part of archive hack
*/
int record_size = 0;



#include "home.h"
#include "cf.h"
#include "counter.h"
#include "vsch.h"
#include "cgiutils.h"
#include "archive.h"
#include "mapping.h"


#include "list.h"

struct columns *thislist;

void *buffer = (void *)0;
int this_record_size = 0;

struct second_query
	{
	query_match_t	query;
	enum vsch_type	vsch;
	char *name;
	} *second_query;
int second_count;


Archive *data_file;


extern int archive_debug;

main( argc, argv )
int argc;
char **argv;
{
int (*print_record_fn)();
int (*print_header_fn)();
int (*print_trailer_fn)();
time_t file_min_time, file_max_time;
int x,y,res;
void *p; 
counter data[2];
PCf config;
char *b,b1[100],*s;
int w;
int count;
query_match_t   q;
struct query_types *types;
time_t min_time = 0, max_time = 0;
PCf cgi_args;
int using_cgi;
int q_type;
int cpdown;
char * config_file_name, *recorder_name;
struct vsch_buf io_buffer;
int suppress_mapping = 0;

vsch_initbuf(&io_buffer,0);

archive_debug = 0;

fprintf(stderr,"begin list query\n");
Cgi_Debug(argc,argv);
CgiGoHome();
system("pwd >&2");

	cgi_args=Cf_New(0);
	Cgi_QueryToCf(cgi_args);

	{
	int mode;
	b=Cf_GetVal("mode",cgi_args);
	if (b)
		switch (b[0])
			{
		case 't':	mode = 1; break;
		case 'h':	mode = 2; break;
		case 'e':	mode = 3; break;
		default:	mode = 1; break;
			}
	else
		mode = 1;

	switch (mode)
		{
	case 1:
		{
		extern int print_record_text(), print_header_text(),
			print_trailer_text();
		printf("content-type: text/plain\n\n");
		print_record_fn = print_record_text;
		print_header_fn = print_header_text;
		print_trailer_fn = print_trailer_text;
		}
		break;
	case 2:
		{
		extern int print_record_html(), print_header_html(),
			print_trailer_html();
		printf("content-type: text/html\n\n");
		print_record_fn = print_record_html;
		print_header_fn = print_header_html;
		print_trailer_fn = print_trailer_html;
		}
		break;
	case 3:
		{
		extern int print_record_excel(), print_header_excel(),
			print_trailer_excel();
		printf("content-type: application/x-excel\n\n");
		print_record_fn = print_record_excel;
		print_header_fn = print_header_excel;
		print_trailer_fn = print_trailer_excel;
		}
		break;
		}
	}

	recorder_name=config_file_name=Cf_GetVal("recorder_name",cgi_args);
	if (! config_file_name)
		{
		printf("no recorder_name\n");
		exit(1);
		}
	config_file_name = nfrConcat("packages/", config_file_name,
			".cfg", NULL);

	query_load_types();

	if ( (! (config=Cf_New(0)) )
		|| Cf_Read(config_file_name,config) )
		{
		perror(config_file_name);
		exit(1);
		}

	thislist = load_conf(config);

	b=Cf_GetVal("query_type",cgi_args);
	if (!b)
		{
		printf("error: no query type \n");
		exit(1);
		}

	switch (b[0])
		{
	case '1':
		q_type=b[0]&3;
		break;
	case 'g':
		printf("no general query yet\n");
		exit(1);
	default:
		printf("bogus query type\n");
		exit(1);
		}

	/*
	* first, make an array to hold the queries for secondary types.
	* This array contains 1 element for each secondary type that
	* we are actually querying on.
	*
	* second_query will be the array of queries.  Yes, it allocates
	* the max memory it could possibly need.  No big deal.
	*/
	for (count=1,types=query_secondary_types; types->name; types++,count++)
		;
	second_query=calloc(count,sizeof(struct second_query));
	if (!second_query)
		nomem();
	/*
	* Loop over the secondary types.  count will be our loop counter.
	* second_count will be how many secondary types we actually have
	* queries for.
	*
	* replace the gets() with something suitable.
	*
	* If we come across time, stuff it away for special handling.
	*
	* For regular types, search the list of columns for one that has
	* the secondary type we are looking for.  If not present, we
	* can just quit right now because it will never match.
	*
	* Compile the query and stash relevant information in second_query[]
	* for use when comparing the data.
	*/
	for (count=0, second_count=0; 
		query_secondary_types[count].name; count++)
		{
		b=Cf_GetVal(query_secondary_types[count].name,cgi_args);
		if (b) while (isspace(*b)) b++;
		if (b && b[0])
			{
			for (x=0; x<thislist->r.num_fields ; x++)
				if (strcmp(thislist->r.f[x].secondary_type,
				    query_secondary_types[count].name) == 0
				   )
					goto secondary_ok;
			printf("no column has that type; nothing can match\n");
			exit(0);
	secondary_ok:
			second_query[second_count].query=
			    query_compile(query_secondary_types[count].type,b);
                        if (!second_query[second_count].query)
                                bad_query("secondary type ",
                                        query_secondary_types[count].name);
			second_query[second_count].vsch=
				query_secondary_types[count].type;
			second_query[second_count].name=
				query_secondary_types[count].name;
			second_count++;
	fprintf(stderr,"secondary - %s\n",b);
	query_debug_printer(second_query[second_count-1].query,
		second_query[second_count-1].vsch);
			}
		}
	
	min_time=max_time=0;

	b=Cf_GetVal("min_time",cgi_args);
	if (b) min_time=atoi(b);
	
	b=Cf_GetVal("max_time",cgi_args);
	if (b) max_time=atoi(b);

fprintf(stderr,"min time %d, max_time %d\n", min_time, max_time);

	/*
	* next, compile primary types and link them to the axis map
	*
	* Each primary type can only be associated with one axis.
	* Find that axis.  Compile the query for the type of
	* that axis and stash it in the axis_map for use when
	* comparing the data.
	*
	* warn of inconsistencies.
	*/
	for (types = query_primary_types; types->name; types++)
		{
		b=Cf_GetVal(types->name,cgi_args);
		if (b) while (isspace(*b)) b++;
		if (b && b[0])
			{
			count=0;
			for (x=0; x<thislist->r.num_fields; x++)
				{
				if (strcmp(types->name,thislist->r.f[x].
					primary_type)==0)
					{
				/* found a column of this type. get the query*/
					if (thislist->r.f[x].type 
						== types->type)
						{
						thislist->c[x].
						primary_type_query=
						   query_compile(types->type,b);
                                                if (!thislist->c[x].
							primary_type_query)
                                                        bad_query(
                                                        "primary type",thislist
							->r.f[x].primary_type);
						count++;
						}
					else
			printf("type in cfg file is wrong representation\n");

					}
				}
			if (count == 0)
				{
				printf("no column types match; nothing can match\n");
				exit(0);
				}
			if (count != 1)
				printf("%d columns with same type!\n",count);
			}
		}

/*
* DO: everywhere, fix the comments
*/
	/*
	* next, compile the specific query for each column, if any
	*/
	count=0;
	for (x=0; x<thislist->r.num_fields; x++)
		{
		sprintf(b1,"column_%d",x);
		b=Cf_GetVal(b1,cgi_args);
		if (b)
			{
			thislist->c[x].column_query = query_compile(thislist->
					r.f[x].type,b);
                        if (!thislist->c[x].column_query)
                                {
                                char b[50];
                                sprintf(b,"column %d",x+1);
                                bad_query(b,"");
                                }
			}
		}

	/*
	* create the diminished column map, if necessary
	*/
	if (q_type == 1)
		{
		int c;
		for (x=0; x<thislist->r.num_fields; x++)
			{
			sprintf(b1,"collapse_%d",x+1);
			b=Cf_GetVal(b1,cgi_args);
			if (b && !strcmp(b,"on"))
				thislist->c[x].diminished=1;
			else
				thislist->c[x].diminished=0;
			}
		}

	b=Cf_GetVal("suppress_mapping",cgi_args);
	if (b && b[0])
		suppress_mapping = 1;

	/* load the type mapping */
	for (x=0; x<thislist->r.num_fields; x++)
		{
		thislist->r.f[x].mapping = mapping_open(thislist->r.f[x].type);
		if ((! suppress_mapping) && ( ! thislist->r.f[x].diminished ))
			{
			mapping_load(thislist->r.f[x].mapping,  "packages",
				recorder_name, thislist->r.f[x].primary_type);
			mapping_load(thislist->r.f[x].mapping, "etc/maps",
				"", thislist->r.f[x].primary_type );
			mapping_load(thislist->r.f[x].mapping,  "packages",
				recorder_name, thislist->r.f[x].secondary_type);
			mapping_load(thislist->r.f[x].mapping,  "etc/maps",
				"", thislist->r.f[x].secondary_type);
			}
		}
/*
* main loop that performs query
*/
	(*print_header_fn)();

	/*
	* now start scanning files
	*/
	data_file = archive_openread(recorder_name, "data", 
		min_time, max_time );
	if (!data_file)
		{
		fprintf(stderr,"archive error %d %s\n",archive_errno,
			astrerror(archive_errno));
		exit(1);
		}

	switch (q_type)
		{
	case 1:
		for (;;)
			{
			if (get_archive(data_file, &io_buffer) < 1)
				break;
			decode_record(thislist, io_buffer.buffer, 
				io_buffer.buffer_size);
			if (match_record())
				{
				(*print_record_fn)();
				}
			}
		}

	(*print_trailer_fn)();

archive_close(data_file);

fprintf(stderr,"end list query\n");
exit(0);
}


/*
* return true if record matches
*/
match_record()
{
int x,y;
void *p;
int match_count=0;

for (x=0; x < thislist->r.num_fields; x++)
	{
	p = thislist->c[x].offset;
	if (query_compare(thislist->c[x].primary_type_query, p, 
			thislist->r.f[x].type, thislist->r.f[x].size))
		match_count++;
	if (query_compare(thislist->c[x].column_query,p,thislist->r.f[x].type
			, thislist->r.f[x].size))
		match_count++;
	}

if (match_count != (thislist->r.num_fields * 2))
	return 0;

/*
* for each query on a secondary type,
*	try matching it against all the columns
*
* a column matches if it has the same secondary type AND the secondary
* type query criteria are met.
* 
* We can use == to compare the char * values in 
*	 if (second_query[y].name == am->secondary_type[x])
* because both are pointers to the same string.  All the type
* name strings point at the same string because of the code
* in query_load_types();
*/
match_count=0;
if (second_count)
    for (y=0; second_query[y].query; y++)
	{
	    for (x=0; x < thislist->r.num_fields; x++)
		{
		if (second_query[y].name == thislist->r.f[x].secondary_type)
			if (query_compare(second_query[y].query,
				thislist->c[x].offset, second_query[y].vsch,
				thislist->r.f[x].size)
			   )
				{
				match_count++;
				break;
				}
		}
	}
/*
* if we matched one for each secondary type queried, we got
* a match.  Having matched this file, we can go on to
* the next one.
*/
if (match_count != second_count)
	{
	return 0;
	}
return 1;
}

bad_query(char *s, char *t)
{
printf("Error:\nBad query in %s %s\n",s,t);
exit(1);
}

