/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   ackhistory.c
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

/* define DEBUG_LEV 1 to get dumps of the queries, and enable cmdline
   debugging */
#define DEBUG_LEV 1

#include "sys-include.h"

#include "cgiutils.h"
#include "libnfr.h"
#include "nfr_res.h"

int main(int argc, char **argv)
{
  ULONG Result = 0;
  PCf QueryFields = NULL;
  char *SerialStr = NULL;
  char *SrcPath = NULL;
  FILE *In = NULL;
  BYTE Buf[256];
  int Bytes = 0;
  int TotalBytes = 0;
  char *errStr = NULL;

  CgiGoHome();

  CGI_DEBUGGER();

  QueryFields = Cf_New(0);
  Cgi_QueryToCf(QueryFields);

  SrcPath = Cf_GetVal("hist_file", QueryFields);
  if(!SrcPath)
    {
      Cgi_Response("ackhistory: no hist_file", 0, 1);
      exit(1);
    }

  In = fopen(SrcPath,"r");
  if(!In)
    {
      errStr = nfrConcat("ackhistory: ", SrcPath, 
			 ": ", strerror(errno), NULL);
      Cgi_Response(errStr, 0, 1);
      exit(1);
    }

  errStr = nfrConcat("history file ", SrcPath, " loaded", NULL);
  Cgi_Response(errStr,0,0);

  while ((Bytes=fread(Buf, 1, sizeof(Buf),In)) > 0)
    TotalBytes += fwrite(Buf,1,Bytes,stdout);

  fclose(In);

  fprintf(stderr,"wrote %d bytes\n", TotalBytes);

  Cf_Delete(QueryFields);
  SExit(0);
}
