/*
        Copyright(C) 1997 Network Flight Recorder, Inc.
        All rights reserved.

        Use and distribution of this software and its source code
        are governed by the terms and conditions of the
        Network Flight Recorder Software License ("LICENSE.TXT")

*/

#include "sys-include.h"
/*
** ----------------------------------------
**
*/

controlSockOpen( host, port )
char * host;
int port;
{
    struct hostent * h;
    struct sockaddr_in sin;
    int controlFd;

    controlFd = socket( AF_INET, SOCK_STREAM, 0 );
    if (controlFd < 0) {
	/* error */
	return -1;
    }

    /*
    ** create the other endpoint address.
    */
    memset( &sin, 0, sizeof(sin) );
    sin.sin_family = AF_INET;
    sin.sin_port = htons(port);

    if (strchr(host, '.') && isdigit(host[0])) {
	unsigned long ha;
	ha = inet_addr(host);
	memcpy( &sin.sin_addr.s_addr, &ha, sizeof(sin.sin_addr.s_addr) );
    } else {
	if ((h = gethostbyname( host )) == 0) {
	    fprintf( stderr, "controlSockOpen: can't find %s/%d\n", host, port );
	    return -1;
	}
	memcpy( &sin.sin_addr.s_addr, h->h_addr, sizeof(sin.sin_addr.s_addr) );
    }

    if (connect( controlFd, (struct sockaddr *)&sin, sizeof(sin) ) < 0) {
	fprintf( stderr, "controlSockOpen: can't connect %s/%d\n", host, port );
	perror("connect");
	return -1;
    }

return controlFd;
}

