/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   call_rc.c
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

/* define DEBUG_LEV 1 to get dumps of the queries, and enable cmdline
   debugging */
#define DEBUG_LEV 1

#include "sys-include.h"

#include "cgiutils.h"
#include "libnfr.h"

void revertSrc()
{
  /* if something's really gotten hosed, try to put back the previous
     version of the files */
  remove("fac_res.src.broken");
  if(!rename("fac_res.src", "fac_res.src.broken"))
    if(rename("fac_res.src.bak", "fac_res.src"))
      rename("fac_res.src.broken", "fac_res.src");
  remove("nfr_res.src.broken");
  if(!rename("nfr_res.src", "nfr_res.src.broken"))
    if(rename("nfr_res.src.bak", "nfr_res.src"))
      rename("nfr_res.src.broken", "nfr_res.src");
  remove("usr_res.src.broken");
  if(!rename("usr_res.src", "usr_res.src.broken"))
    if(rename("usr_res.src.bak", "usr_res.src"))
      rename("usr_res.src.broken", "usr_res.src");
}

int main(int argc, char **argv)
{
  int Result = 0;
  char *errStr = NULL;

  CgiGoHome();
  CGI_DEBUGGER();

  if(chdir("etc/resources") != 0)
    {
      errStr = nfrConcat("etc/resources: ", strerror(errno), NULL);
      Cgi_Response(errStr, 0, 1);
      exit(1);
    }

  /* bug: this is pretty ugly - fix later */


  fprintf(stderr, "../../bin/rc -o nfr fac_res.src nfr_res.src\n");
  Result = system("../../bin/rc -o nfr fac_res.src nfr_res.src > /dev/null");
  if(Result != 0)
    {
      Cgi_Response("callrc: failed for built-in definitions", 0, 1);
      revertSrc();
      exit(1);
    }

  fprintf(stderr, "../../bin/rc -o usr fac_res.src usr_res.src\n");
  Result = system("../../bin/rc -o usr fac_res.src usr_res.src > /dev/null");
  if(Result != 0)
    {
      Cgi_Response("callrc: failed for user resource definitions", 0, 1);
      revertSrc();
      exit(1);
    }

  /* safe to remove the backup files now */
  remove("fac_res.src.bak");
  remove("nfr_res.src.bak");
  remove("usr_res.src.bak");

  /* get nfrd up to date with the new resource defs */
  chdir("../../");
  fprintf(stderr, "echo alert init | ./bin/control > /dev/null\n");
  Result = system("echo alert init | ./bin/control > /dev/null");
  
  fprintf(stderr, "./bin/alertd -r\n");
  Result = system("./bin/alertd -r");

  Cgi_Response("new resource definitions committed", 0, 0);
  exit(0);
}

