/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   cfedit.c
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

#include "sys-include.h"

#define DEBUG_LEV 1

#include "cgiutils.h"
#include "libnfr.h"

int main(int argc, char **argv)
{
  PCf pCf;
  PCf QueryFields;
  FILE *TpltFile;
  char *CfName = NULL;
  char *TpltName = NULL;

  puts("Content-type: text/html\n\n");

  CgiGoHome();

  CGI_DEBUGGER();

  QueryFields = Cf_New(0);
  Cgi_QueryToCf(QueryFields);	/* handle GETs or POSTs */
  pCf = Cf_New(0);
  CfName = Cf_ExpandVal("cf_name", QueryFields);
  if(!CfName)
    {
      fprintf(stderr,"Error: no cf_name field");
      exit(1);
    }
  TpltName = Cf_ExpandVal("tplt_name", QueryFields);
  if(!TpltName)
    {
      fprintf(stderr,"Error: no cf_name field");
      exit(1);
    }
  Cf_Read(CfName, pCf);
  TpltFile = fopen(TpltName, "r");
  if(!TpltFile)
    {
      perror(TpltName);
      exit(1);
    }
  Cgi_CfToForm(pCf, TpltFile, stdout);
  fclose(TpltFile);
  Cf_Delete(QueryFields);
  Cf_Delete(pCf);
  SExit(0);
}
