/*
        Copyright(C) 1997 Network Flight Recorder, Inc.
        All rights reserved.

        Use and distribution of this software and its source code
        are governed by the terms and conditions of the
        Network Flight Recorder Software License ("LICENSE.TXT")

By Mark Sienkiewicz / NFR

*/

#include "sys-include.h"

#define DEBUG_LEV 1

#include "cgiutils.h"
#include "libnfr.h"

int main(int argc, char **argv)
{
  PCf input = NULL;
  char *filename = NULL;
  FILE *f;
  int n;
  char *s;
  char b[1024];

  CGI_DEBUGGER();

  CgiGoHome();

  printf("Content-type: text/plain\n\n");

  input = Cf_New(0);
  Cgi_QueryToCf(input);

  filename = Cf_GetVal("filename", input);
  if (!filename)
	{
	printf("error bad cgi invocation - no filename\n");
	exit(0);
	}

  if (! check_local_filename(filename))
	{
	printf("not local filename.\n");
	exit(1);
	}

  if (Cf_GetVal("get",input))
	{
	int x;
	struct stat sb;
	f = fopen(filename,"r");
	if (!f)
		goto err;
	if (fstat(fileno(f),&sb) == -1)
		goto err;
	x=sb.st_size;	/* reduce from possible long long */
	if (! Cf_GetVal("quiet",input))
		printf("ok %d\n",x);
	while ((n=fread(b,1,sizeof(b),f)) > 0)
		fwrite(b,1,n,stdout);
	fclose(f);
	exit(0);
	}
  if (s=Cf_GetVal("put",input))
	{
	f = fopen(filename,"w");
	if (!f)
		goto err;
	n=strlen(s);
	if (fwrite(s,1,n,f) != n)
		goto err;
	fclose(f);
	printf("ok\n");
	exit(0);
	}

  printf("error bad cgi invocation - no put/get\n");
  exit(0);

err:
	printf("error %s\n",sys_errlist[errno]);
	exit(0);
}


check_local_filename(char *s)
{
char *save_s = s;
struct stat sb;
if (*s == '/')
	{
	fprintf(stderr,"%s starts with /\n",save_s);
	return 0;
	}
if (*s == '.')
	{
	fprintf(stderr,"%s starts with .\n",save_s);
	return 0;
	}
while (s)
	{
	s=strchr(s+1,'/');
	if (s)
		{
		if (s[1] == '.')
			{
			fprintf(stderr,"%s contains /. \n",save_s);
			return 0;
			}
		}
	}
if (stat(save_s,&sb) != -1)
	{
	if (((sb.st_mode & S_IFMT) != S_IFREG) && ((sb.st_mode & S_IFMT)
		!= S_IFLNK))
		{
		fprintf(stderr,"%s not regular file\n",save_s);
		return 0;
		}
	}
return 1;
}
