/*
        Copyright(C) 1997 Network Flight Recorder, Inc.
        All rights reserved.

        Use and distribution of this software and its source code
        are governed by the terms and conditions of the
        Network Flight Recorder Software License ("LICENSE.TXT")

By Mark Sienkiewicz / NFR

*/

#include <stdio.h>

main(argc,argv)
char *argv[];
{
FILE *f, *fp;
char b[1000];
int fd;
int j, avm, cpu, prevpackets=0, totalpackets;
int port;

printf("Content-type: text/plain\n\n");
fflush(stdout);

CgiGoHome();

f=fopen("etc/sock_id","r");
if (!f)
	{
	perror("nph-stathack opens etc/sock_id\n");
	exit(1);
	}
if (!fgets(b,sizeof(b),f))
	{
	fprintf(stderr,"nph-stathack reads etc/sock_id\n");
	exit(1);
	}
port=atoi(b);
if ((port < 1) || ( port > 65535))
	{
	fprintf(stderr,"nph-stathack finds bogus port number in etc/sock_id\n");
	exit(1);
	}
fclose(f);

fd=controlSockOpen("localhost",port);

fp=fdopen(fd,"r");

f=popen("vmstat 1","r");

if (!f)
	{
	fprintf(stderr,"nph-stathack can't get vmstat\n");
	exit(1);
	}

while (fgets(b,sizeof(b),f))
	{
	if (sscanf(b,
	    "%d %d %d %d %d  %d %d %d %d %d  %d %d %d %d %d  %d %d %d %d",
		&j, &j, &j, &avm, &j,
		&j, &j, &j, &j, &j,
		&j, &j, &j, &j, &j,
		&j, &j, &j, &cpu) != 19)
			continue;
	write(fd,"stats packet\n",sizeof("stats packet\n")-1);
	while (fgets(b,sizeof(b),fp))
		{
		char *s;
		if (strncmp("packets: total ",b,
			sizeof("packets: total ")-1) == 0)
			totalpackets= atoi(b+14);
		s=(char *)strchr(b,' ');
		if (strncmp(s," done",sizeof(" done")-1) == 0)
			goto done;
		}
	exit(0);	/* EOF implies connection lost */
done:
	cpu = 100 - cpu;	/* convert idle to busy percentage */
	if (cpu < 0)
		cpu = 0;
	printf("%d %d %d %d\n",avm,cpu,totalpackets - prevpackets,totalpackets);
	fflush(stdout);
	prevpackets=totalpackets;
	}
exit(0);
}
