/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   testalert.c
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

/* define DEBUG_LEV 1 to get dumps of the queries, and enable cmdline
   debugging */
#define DEBUG_LEV 1

#include "sys-include.h"

#include "cgiutils.h"
#include "libnfr.h"
#include "nfr_res.h"
#include "librc.h"

int main(int argc, char **argv)
{
  PCf QueryFields = NULL;
  ULONG result = 0;
  ULONG alertnum = 0;
  char alertnumStr[12];
  char resultStr[12];
  ULONG dummy = 0;
  char *subject = NULL;
  char *errStr = NULL;

  CgiGoHome();

  CGI_DEBUGGER();

  QueryFields = Cf_New(0);
  Cgi_QueryToCf(QueryFields);

  subject = Cf_GetVal("alertnum", QueryFields);
  if(subject)
    alertnum = strtoul(subject, NULL, 0);
  else
    {
      subject = Cf_GetVal("alertId", QueryFields);
      if(subject)
	UsrAlert_GetCodes("duh", &dummy, subject, &alertnum);
    }

  if(!subject)
    result = 1;
  else
    {
      sprintf(alertnumStr, "0x%.8lX", alertnum);
      fprintf(stderr, "trying to send alert: %s\n", alertnumStr);

      result = Alert_Args_GenerateEx(__FILE__, __LINE__,
				     NFR_SRC_ALERTD_TEST, alertnum,
				     "<insert_1>",
				     "<insert_2>",
				     "<insert_3>",
				     "<insert_4>",
				     "<insert_5>",
				     "<insert_6>",
				     "<insert_7>",
				     "<insert_8>",
				     "<insert_9>",
				     NULL);

      free(subject);  /* aw..., that's nice. */ 
    }

  if(result)
    {
      if(errno)
	{
	  errStr = nfrConcat("couldn't send alert (", alertnumStr,
			     ") :", strerror(errno), NULL);
	}
      else
	{
	  sprintf(resultStr, "0x%.8lX", result);
	  errStr = nfrConcat("couldn't send alert (", alertnumStr,
			     ") : internal error #", resultStr,  NULL);
	}	
    }
  else
    {
      errStr = nfrConcat("successfully sent alert (", alertnumStr, ")");
    }

  Cgi_Response(errStr, 0, result);
  exit(result);
}
