#!/sbin/sh
#
# /etc/init.d/nfrstatrt:
#
#    Start/Stop the NFR Monitoring Engine and associated services
# 
#   Solaris:
#       Link from /etc/init.d/nfrstart to /etc/rc2.d/S90nfr
#

NFRHOME=INSTALL
export NFRHOME

set -x

case $1 in
'start')
	if [ -x ${NFRHOME}/bin/nfrwatch ] && [ -f ${NFRHOME}/etc/nfr.conf ]
	then
        	${NFRHOME}/bin/nfrwatch ${NFRHOME}/etc/nfr.conf
	fi
        ;;
'stop')
        #
        # Need the shutdown command to send.
        #
        pid=`cat ${NFRHOME}/etc/run/nfrwatch.pid`
        if test "$pid"
        then
                kill -TERM $pid
        fi
        ;;
*)
        echo "usage: /etc/rc2.d/S90nfr {start|stop}"
        ;;
esac
