/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   cgiutils.h
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

#ifndef CGIUTILS_H_
#define CGIUTILS_H_

#include "libnfr.h"

#if DEBUG_LEV > 0
#define CGI_DEBUGGER() Cgi_Debug(argc, argv)
#else 
#define CGI_DEBUGGER()
#endif

#define ACCEPT_POST (1L << 0)
#define ACCEPT_GET  (1L << 1)

void Cgi_Debug(int, char **);
void Cgi_InitLocalTest(char *);
int Cgi_DumpQuery(char *);

int MimeHeaderEx(FILE *, char *, char *, char *, char *, int, char *);
#define MimeHeader(F, RC, D, CT, DT) MimeHeaderEx(F, RC, D, NULL, CT, -1, DT)

int Cgi_QueryToCfEx(ULONG, TCf *);
#define Cgi_PostReqToCf(PCF) Cgi_QueryToCfEx(ACCEPT_POST, PCF)
#define Cgi_GetReqToCf(PCF) Cgi_QueryToCfEx(ACCEPT_GET, PCF)
#define Cgi_QueryToCf(PCF) Cgi_QueryToCfEx(ACCEPT_POST | ACCEPT_GET, PCF)

int Cgi_CfToForm(TCf *, FILE *, FILE *);
enum
{
  FORM_INIT,
  FORM_GET_VARNAME
};

int Cgi_Response(char *, int, int);

/* these are taken from the ncsa httpd distribution */
char x2c(char *);
void unescape_url(char *);
void plustospace(char *);
void escape_shell_cmd(char *);
int rind(char *, char);
int ind(char *, char);

#endif /* CGIUTILS_H_ */
