/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   fifo.h
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

/****************************************************************************
 * fifo.h structs and functions used to handle fifos
 ***************************************************************************/
#ifndef FIFO_H_
#define FIFO_H_

#include "xtypes.h"
#include "dgram.h"

int Fifo_Create(char *);	/* FIFO name */

int Fifo_OpenRead(char *);	/* FIFO name */

int Fifo_OpenWrite(char *);	/* FIFO name */

void Fifo_Destroy(char *);	/* FIFO name */

int Fifo_SendDGram(char *,	/* FIFO name */
		   int,		/* DGram type */
		   void *,	/* pointer to data to send */
		   int,		/* length of data to send */
		   int);	/* timeout in microseconds */


#endif
