/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   librc.h
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

#ifndef LIBRC_H_
#define LIBRC_H_

#include "restab.h"


/* global vars */
extern PResTab gpResTab;
extern ULONG gErrors;
extern ULONG gWarnings;
/* extern BOOL gLazyDefs; */ /* bug: get rid of this */
extern BOOL gFixedResFlag;
extern ULONG gVerbosity;
extern char *gpResDir;

/* parse modes */

#define RC_MODE_SCAN 1
#define RC_MODE_COMPILE (1 << 1)
#define RC_MODE_MERGE_DIFFS (1 << 2)
#define RC_MODE_USER (1 << 3)


/* from lib/rc/parse.c */
void Rc_Init(void);
void Rc_Cleanup(void);
ULONG Rc_Parse(ULONG, FILE *, FILE *, TResTab *);

#endif /* sentry */
