/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   resid.h
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

#ifndef RESID_H_
#define RESID_H_

#include "xtypes.h"

#define RESID_REQ_FIELDS  ULONG ResCode; USHORT IdLen; char *Id; \
                          USHORT DispNameLen; char *DispName; char State

typedef struct TResId
{
  RESID_REQ_FIELDS;
} TResId, *PResId;

enum
{
  RESID_STATE_FREE,
  RESID_STATE_STABLE,
  RESID_STATE_ADDED,
  RESID_STATE_DELETED,
  RESID_STATE_ALTERED
};

TResId *ResId_New(void);
void ResId_Delete(TResId *);
ULONG ResId_Read(TResId *, ULONG *, FILE *);
ULONG ResId_Write(TResId *, ULONG *, FILE *);
int ResId_SetId(char *, USHORT, PResId);

#endif /* sentry */
