/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   restab.h
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

#ifndef RESTAB_H_
#define RESTAB_H_

#include "libnfr.h"

typedef struct TResTab
{
  TSymTab *SymTab;
  TNIList *RangeList;
} TResTab, *PResTab;


TResTab *ResTab_New(void);

/*********************************************************************
 * ULONG ResTab_DefineRange(char *RangeId, USHORT Min, USHORT Max,
 * char *DispName, char MemberType, TRangeRes **ppNewRange, 
 * TResTab *pResTab)
 *********************************************************************/
ULONG ResTab_DefineRange(char *, USHORT , USHORT ,  char *, char , 
			 TRangeRes **, TResTab *);


/*********************************************************************
 * ULONG ResTab_AssignResNo(ULONG Preset, char* RangeId, TResId* pNewRes, TResTab*
 * pResTab)
 *********************************************************************/
ULONG ResTab_AssignResNo(ULONG Preset, char *, TResId *, TResTab *);



/*********************************************************************
 * ResTab_GetRes(char *Id, TResTab *pResTab) - returns a pointer to a
 * TResId structure with the specified Id.  If the Id is not found
 * NULL is returned.
 *********************************************************************/
TResId *ResTab_Get(char *, TResTab *);


/*********************************************************************
 * ResTab_RemoveRes(char *Id, TResTab *pResTab) - returns a pointer to
 * a TResId structure with the specified Id.  The TResId is removed
 * from pResTab.  If the Id is not found NULL is returned.
 *********************************************************************/
TResId *ResTab_Remove(char *, TResTab *);


/*********************************************************************
 * ULONG ResTab_Insert(TResId *pResId, TResTab *pResTab)
 *********************************************************************/
ULONG ResTab_Insert(TResId *, TResTab *);


/*********************************************************************
 * ULONG ResTab_MergeDiffs(char *SrcName, TResTab *pDiffTab)
 *********************************************************************/
ULONG ResTab_MergeDiffs(char *, TResTab *);

/*********************************************************************
 * ULONG ResTab_Dump(TResTab *pResTab, FILE *Out)
 *********************************************************************/
ULONG ResTab_Dump(TResTab *, FILE *);


/*********************************************************************
 * ULONG ResTab_Load(TResTab *pResTab, FILE *In)
 *********************************************************************/
ULONG ResTab_Load(TResTab *, FILE *In);


#endif /* sentry */
