/*
*        Copyright(C) 1997 Network Flight Recorder, Inc. 
*        All rights reserved. 
* 
*        Use and distribution of this software and its source code 
*        are governed by the terms and conditions of the 
*        Network Flight Recorder Software License ("LICENSE.TXT") 
* 
*By Mark Sienkiewicz / NFR 
* 
*/ 


/*
* WARNING:  Due to bugs in various versions of yacc, the C code that
* this file produces is edited by sed afterwards.  It will say
*	s/yy/yy_counter_/g
*
* I suggest you not use variables with yy in their name.
*/



%{
#define YYDEBUG 1

#include "sys-include.h"

#include "counter.h"
#include "vsch.h"
#include "query.h"

%}

%union  {
#include "query_union.h"
}

%{

extern char *yacc_input_string;

/*
* yylex changed to yy_counter_lex by sed
*/
yylex()
{
int c;
c= (*yacc_input_string ? *yacc_input_string++ : -1 );
return c;
}

/*
* yyerror changed to yy_counter_error by sed
*/
static yyerror(char *s)
{
extern had_yacc_error;
had_yacc_error=1;
}


%}

%%

list:   
		{
		}
	| listitem
		{
		query_add_list($1);
		$$=$1;
		}
        | list ',' listitem
		{
		query_add_list($3);
		$$ = $1;
		}
	;

listitem: range
		{
		$$ = $1;
		}
	| number
		{
		$$ = $1;
		}
	;

range:  number '-' number 
		{
		$$.type=VSCH_COUNTER;
		$$.counter_range.first = $1.counter_range.first;
		$$.counter_range.second = $3.counter_range.first;
		}
	;

number:	wsp num_bit wsp
		{
		$$ = $2;
		}
	;

num_bit:	digit  
		{
		$$=$1;
		$$.counter_range.second = $1.counter_range.first;
		$$.type = VSCH_COUNTER;
		}
	| num_bit digit 
		{ 
		$$.type = VSCH_COUNTER;
		$$.counter_range.first = counter_add(
			counter_mul($1.counter_range.first,
				counter_from_int(10)),
			$2.counter_range.first
			) ; 
		$$.counter_range.second = $$.counter_range.first;
		}
	;

digit:	  '0' { $$.counter_range.first=counter_from_int(0); }
	| '1' { $$.counter_range.first=counter_from_int(1); }
	| '2' { $$.counter_range.first=counter_from_int(2); }
	| '3' { $$.counter_range.first=counter_from_int(3); }
	| '4' { $$.counter_range.first=counter_from_int(4); }
	| '5' { $$.counter_range.first=counter_from_int(5); }
	| '6' { $$.counter_range.first=counter_from_int(6); }
	| '7' { $$.counter_range.first=counter_from_int(7); }
	| '8' { $$.counter_range.first=counter_from_int(8); }
	| '9' { $$.counter_range.first=counter_from_int(9); }
	;

wsp: 	
	| whitespacec
	| wsp whitespacec
	;
	
whitespacec: ' ' | '\n' | '	' ;

