/*
*        Copyright(C) 1997 Network Flight Recorder, Inc. 
*        All rights reserved. 
* 
*        Use and distribution of this software and its source code 
*        are governed by the terms and conditions of the 
*        Network Flight Recorder Software License ("LICENSE.TXT") 
* 
*By Mark Sienkiewicz / NFR 
* 
*/ 

 
/*
* WARNING:  Due to bugs in various versions of yacc, the C code that
* this file produces is edited by sed afterwards.  It will say
*       s/yy/yy_ether_/g
*
* I suggest you not use variables with yy in their name.
*/


%{
#define YYDEBUG 1

#include "sys-include.h"

#include "counter.h"
#include "vsch.h"
#include "query.h"

%}

%union  {
#include "query_union.h"
}

%{

extern char *yacc_input_string;

/*
* changed to yy_ether_lex by sed
*/
yylex()
{
int c;
c= (*yacc_input_string ? *yacc_input_string++ : -1 );
return c;
}

/*
* changed to yy_ether_error by sed
*/
static yyerror(char *s)
{
extern had_yacc_error;
had_yacc_error=1;
}


%}

%%

list:   
		{
		}
	| listitem
		{
		query_add_list($1);
		$$=$1;
		}
        | list ',' listitem
		{
		query_add_list($3);
		$$ = $1;
		}
	;

listitem: range
		{
		$$ = $1;
		}
        | ethermac
		{
		$$ = $1;
		}
	;

range:	ethermac '-' ethermac 
		{
		$$ = $1;
		memcpy( $$.ether.second, $3.ether.first, 4 );
		{ 
		int x; 
		for (x=0; x<6; x++) 
			$$.ether.wild[x] = $1.ether.wild[x] | $3.ether.wild[x];
		}
		}
	;

ethermac: wsp octet ':' octet ':' octet 
		':' octet ':' octet ':' octet wsp
		{ 
		$$.type=VSCH_IP;
		$$.ether.first[0]= $2.integer.first;
		$$.ether.first[1]= $4.integer.first;
		$$.ether.first[2]= $6.integer.first;
		$$.ether.first[3]= $8.integer.first;
		$$.ether.first[4]= $10.integer.first;
		$$.ether.first[5]= $12.integer.first;
		memcpy( $$.ether.second, $$.ether.first, 6 );
		$$.ether.wild[0]= $2.integer.misc;
		$$.ether.wild[1]= $4.integer.misc;
		$$.ether.wild[2]= $6.integer.misc;
		$$.ether.wild[3]= $8.integer.misc;
		$$.ether.wild[4]= $10.integer.misc;
		$$.ether.wild[5]= $12.integer.misc;
		}
	;

octet:	digit digit
		{
		$$.type = VSCH_INT;
		$$.integer.first = $1.integer.first * 16 + $2.integer.first ;
		$$.integer.second = $$.integer.first;
		$$.integer.misc = 0;
		}

	| digit
		{
		$$.type = VSCH_INT;
		$$.integer.first = $1.integer.first;
		$$.integer.second = $$.integer.first;
		$$.integer.misc = 0;
		}
	| '*'
		{
		$$.type = VSCH_INT;
		$$.integer.first = 0;
		$$.integer.misc = 1;
		}
	;



digit:	  '0' { $$.counter_range.first=counter_from_int(0); }
	| '1' { $$.counter_range.first=counter_from_int(1); }
	| '2' { $$.counter_range.first=counter_from_int(2); }
	| '3' { $$.counter_range.first=counter_from_int(3); }
	| '4' { $$.counter_range.first=counter_from_int(4); }
	| '5' { $$.counter_range.first=counter_from_int(5); }
	| '6' { $$.counter_range.first=counter_from_int(6); }
	| '7' { $$.counter_range.first=counter_from_int(7); }
	| '8' { $$.counter_range.first=counter_from_int(8); }
	| '9' { $$.counter_range.first=counter_from_int(9); }
	| 'a' { $$.counter_range.first=counter_from_int(10); }
	| 'b' { $$.counter_range.first=counter_from_int(11); }
	| 'c' { $$.counter_range.first=counter_from_int(12); }
	| 'd' { $$.counter_range.first=counter_from_int(13); }
	| 'e' { $$.counter_range.first=counter_from_int(14); }
	| 'f' { $$.counter_range.first=counter_from_int(15); }
	| 'A' { $$.counter_range.first=counter_from_int(10); }
	| 'B' { $$.counter_range.first=counter_from_int(11); }
	| 'C' { $$.counter_range.first=counter_from_int(12); }
	| 'D' { $$.counter_range.first=counter_from_int(13); }
	| 'E' { $$.counter_range.first=counter_from_int(14); }
	| 'F' { $$.counter_range.first=counter_from_int(15); }
	;

wsp: 	
	| whitespacec
	| wsp whitespacec
	;
	
whitespacec: ' ' | '\n' | '	' ;

