/***************************************************************************** 
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT") 

  File:   adebug.c 
  Author: Kent Landfield <kent@nfr.net>
 
 *****************************************************************************/  
#include <stdio.h>
#include <varargs.h>

int archive_debug = 0;  /* Set in program if wanting to turn on debugging */

/*
** Stream is a FILE * that changes throughout the program if necessary.
** When a new output file (stream) is opened, stream is set to point to
** that so this routine can be used without passing the stream.
*/
FILE *stream = stderr;

/*VARARGS0*/
void adebug(va_alist)    /* adebug (format,arg1,arg2,....argn) */
va_dcl
{
    va_list args;
    char *format;

    if (archive_debug) {
        va_start(args);
        format = va_arg(args, char *);    /* get format to use */
        (void) vfprintf(stream,format,args);
        va_end(args);
    }
}
