/***************************************************************************** 
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT") 

  File:   aindex.c 
  Author: Kent Landfield <kent@nfr.net>
 
 *****************************************************************************/  
#include "sys-include.h"
#include "archive.h"

/*
******************************************************************
** archive_write_index 
**
** Abstract:   Write an index record to the appropriate index file.
**
** Parameters: struct Archive pointer returned from archive_openwrite()
**
** Returns:       1 - success, 0 failure and  archive_errno set
******************************************************************
*/

int archive_write_index(Archive *rkive)
{
    /* write the record to the index */

    if (fprintf(rkive->ifp,"%s %s %s %ld\n", rkive->head.backend,
        (*rkive->head.ctype ? rkive->head.ctype : "None"),
        rkive->path, rkive->head.starttime) < 0) {
        archive_errno = ARCHIVE_INDEX_WRITEFAILED;
        return(0);
    }
    fflush(rkive->ifp);
    return(1);
}

