/***************************************************************************** 
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT") 

  File:   astrerror.c 
  Author: Kent Landfield <kent@nfr.net>
 
 *****************************************************************************/

#include <string.h>

#define UPREFIX "Unknown error: "

char *astrerror(int num)
{
        extern int archive_nerr;
        extern char *archive_errlist[];

        static char ebuf[40] = UPREFIX;         /* 64-bit number + slop */
        register unsigned int aerr;
        register char *p, *t;
        char tmp[40];

        aerr = num;                          /* convert to unsigned */
        if (aerr < archive_nerr)
                return(archive_errlist[aerr]);

        /* Do this by hand, so we don't include stdio(3). */
        t = tmp;
        do {
                *t++ = "0123456789"[aerr % 10];
        } while (aerr /= 10);
        for (p = ebuf + sizeof(UPREFIX) - 1;;) {
                *p++ = *--t;
                if (t <= tmp)
                        break;
        }
        return(ebuf);
}
