/***************************************************************************** 
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT") 

  File:   dump_rkive.c 
  Author: Kent Landfield <kent@nfr.net>
 
 ****************************************************************************/ 

#include "sys-include.h"
#include "archive.h"

char *atime(sometime)
time_t sometime;
{
        struct tm *now;
        static char dtstr[80];

        now = localtime(&sometime);
        sprintf(dtstr,"%.2d/%.2d/%.2d %.2d:%.2d:%.2d",now->tm_mon,now->tm_mday,now->tm_year,now->tm_hour,now->tm_min,now->tm_sec);
        return(dtstr);
}

void dump_rkive(rkive)
Archive *rkive;
{
    fprintf(stderr,"\nArchive File: = [%s]\n", 
                rkive->path == NULL ? "NULL" : rkive->path);
    fprintf(stderr,"Index File    = [%s]\n", 
                rkive->indexpath == NULL ? "NULL" : rkive->indexpath);

    fprintf(stderr,"Backend       = [%s]\n", 
                rkive->head.backend == NULL ? "NULL" : rkive->head.backend);
    fprintf(stderr,"Content Type  = [%s]\n", 
                *rkive->head.ctype ? rkive->head.ctype : "None Specified");
    fprintf(stderr,"CF Version    = [%s]\n", 
                rkive->head.cfversion == NULL ? "NULL" : rkive->head.cfversion);

    fprintf(stderr,"Starttime     = [%s]\n", 
               rkive->head.starttime == 0  ? "NOTSET" : atime(rkive->head.starttime));

    fprintf(stderr,"Endtime       = [%s]\n", 
               rkive->head.endtime == 0  ? "NOTSET" : atime(rkive->head.endtime));

    fprintf(stderr,"Archive Size  = [%ld]\n", rkive->head.archive_size);

    fprintf(stderr,"DataStart     = [%ld]\n", rkive->head.datastart);
    fprintf(stderr,"maxreclen     = [%ld]\n", rkive->head.maxreclen);
    fprintf(stderr,"\n");
    fprintf(stderr,"Recorder Blob = [%s]\n", 
                rkive->info == NULL ? "NULL" : rkive->info);
    fprintf(stderr,"\n");
    fprintf(stderr,"Info Read     = [%d]\n", rkive->info_read);

    fprintf(stderr,"Operation     = [%s]\n", 
                rkive->op == ARCHIVE_READ ? "READ" : 
                rkive->op == ARCHIVE_READ_CONTENT_TYPE ? "READ-CONTENT-TYPE" : "WRITE");

    fprintf(stderr,"PathFormat    = [%s]\n",
                rkive->pathfmt == NULL ? "NULL" : rkive->pathfmt);
    fprintf(stderr,"Record 1 len  = [%ld]\n", rkive->rec1len);
    fprintf(stderr,"Bytes read    = [%ld]\n", rkive->bytesread);
    fprintf(stderr,"Bytes written = [%ld]\n", rkive->byteswritten);
    fprintf(stderr,"RollSize      = [%ld]\n", rkive->rollsize);
    fprintf(stderr,"RollTime      = [%ld]\n", rkive->rolltime);
    fprintf(stderr,"RollTimeval   = [%ld]\n", rkive->rtimeval);
    fprintf(stderr,"Lasttime      = [%ld]\n", rkive->lasttime);
    fprintf(stderr,"Last Rec Pos  = [%ld]\n", rkive->last_rec_pos);
}


