/***************************************************************************** 
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT") 

  File:   free_aow.c 
  Author: Kent Landfield <kent@nfr.net>
 
 ****************************************************************************/ 

#include "sys-include.h"
#include "archive.h"

/*
***************************************************************
** free_aow_mem - free the rive structure allocated memory
**
** Parameters:    pointer to alocated struct Archive
**
** Returns:       Nothing
***************************************************************
*/

void free_aow_mem(rkive)
Archive *rkive;
{
    if (rkive->info)
        free (rkive->info);
    if (rkive->path)
        free(rkive->path);
    if (rkive->indexpath)
        free(rkive->indexpath);
    if (rkive->pathfmt)
        free(rkive->pathfmt);
    if (rkive)
        free(rkive);
}
