/***************************************************************************** 
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT") 

  File:   mkdirs.c 
  Author: Kent Landfield <kent@nfr.net>
 
 *****************************************************************************/ 

#include "sys-include.h"

extern int errno;

/*
**************************************************************** 
** makedirs
** A mkdir routine that makes all intermediate directories as well.
** (Will change the fprintf to an alert when I figure them out...)
**************************************************************** 
*/

int makedirs(char *dirpath)
{
    register char *p;
    struct stat sb;
    int ch;

    for (p = dirpath;; ++p) {
        if (!(*p) || *p  == '/') {
            if (p == dirpath)
                continue;
            ch = *p;
            *p = '\0';
            if (stat(dirpath, &sb)) {
                if (errno != ENOENT || mkdir(dirpath, 0777) < 0) {
                   (void)fprintf(stderr,"mkdir: %s: %s\n",
                                 dirpath,strerror(errno));
                   return(0);
                }
            }
            *p = ch;
            if (!(*p))
                break;
        }
    }
    return(1);
}

