/***************************************************************************** 
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT") 

  File:   perr.c 
  Author: Kent Landfield <kent@nfr.net>
 
 *****************************************************************************/ 

#include "sys-include.h"
#include "archive.h"

#define USAGE  "usage: %s archive_error value\n"

int verbose = 0;

int main(int argc, char **argv)
{
   extern int optind;
   extern int opterr;

   int c;

   opterr = 0;
   verbose = 0;

   if (argc > 1) {
      while ((c = getopt(argc, argv, "p:v")) != EOF) {
         switch (c) {
             case 'v':
                 verbose++;
                 break;
             default:
                 fprintf(stderr,USAGE,argv[0]);
                 return(1);
         }
      }
   }
   for (; optind < argc; optind++) {    /* process files to print */
        c = atoi(argv[optind]);

        printf("%d - %s\n", c, astrerror(c));
   }
   return(0);                              /* terminate this process */
}

