/*
** Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
** All rights reserved.
**
** Use and distribution of this software and its source code
** are governed by the terms and conditions of the
** Network Flight Recorder Software License ("LICENSE.TXT")
*/

#include <stdio.h>

#include "nfrd.h"


/*
** Display.
** just call the local display function to dump the current packet.
*/
void
nfr_blt_display(Machine *m,int argc,int firstarg,int result)
{
	int verbose = 0;
	extern void Display( int, char * );
	char * msg = "nfrd builtin display ";

	while (argc-- > 0) {
	    MemVal * ap = &m->m_mem[firstarg+argc];
	    switch(ap->typ) {
		case NFR_TYPE_STR:
			if (strcmp( ap->val.c, "hex" ) == 0) {
			    verbose = 1;
			} else if (strcmp( ap->val.c, "verbose") == 0) {
			    verbose = 1;
			} else {
			    msg = ap->val.c;
			}
			break;
		case NFR_TYPE_INT:
			verbose = ap->val.i;
			break;
			
		default:	/* silently ignore */
			break;
	    }
	}
	Display( verbose, msg );

	/* echo does not return a value. put a NULL on the stack */
	m->m_mem[result].val.i = NFR_ERR_USER;
	m->m_mem[result].typ = NFR_TYPE_ERR;
	
}
