/*
** Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
** All rights reserved.
**
** Use and distribution of this software and its source code
** are governed by the terms and conditions of the
** Network Flight Recorder Software License ("LICENSE.TXT")
*/


#include <stdio.h>

#include "nfrd.h"

/*
** in-net.
**
** Three parameters... returns an int, describing true or false.
**
** innet( host, net-addr, net-mask );
**
*/
void
nfr_blt_innet(Machine *m,int argc,int firstarg,int result)
{
	MemVal * hp = &m->m_mem[firstarg]; /* host */
	MemVal * np = &m->m_mem[firstarg+1]; /* net */
	MemVal * mp = &m->m_mem[firstarg+2]; /* mask */

	if ((hp->typ != NFR_TYPE_IPV4HOST)
	|| (np->typ != NFR_TYPE_IPV4HOST)
	|| (mp->typ != NFR_TYPE_INT)) {
		Alert_Args_Generate( NFR_SRC_NFRD, NFR_NFRD_INNETERR,
		    util_type2str(hp->typ), util_type2str(np->typ),
		    util_type2str(mp->typ), 0 );
		m->m_mem[result].typ = NFR_TYPE_ERR;
		m->m_mem[result].val.i = NFR_ERR_USER;
		return;
	}

	m->m_mem[result].typ = NFR_TYPE_INT;
	m->m_mem[result].val.i = ( (hp->val.i & htonl(mp->val.i)) == np->val.i );
	return;
}
