/*
** Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
** All rights reserved.
**
** Use and distribution of this software and its source code
** are governed by the terms and conditions of the
** Network Flight Recorder Software License ("LICENSE.TXT")
*/


#include <stdio.h>

#include "nfrd.h"


/*
** recorderNew.
**
** Builtin function which returns a recorer type.
** Usage:
**
** $n = recorderNew( name );
*/

void
nfr_blt_recorderNew(Machine *m,int argc,int firstarg,int result)
{
    MemVal * v = &m->m_mem[firstarg];
    recorder_t * r = 0;

    if (argc > 1) {
	/* XXX currently we only support one argument.
	** the name of the recorder.
	*/
    }

    switch(v.typ) {
	case	NFR_TYPE_STR:
	    r = recorderNew( v.val.c );
	break;

	default:
	case	NFR_TYPE_ERR:
	break;
    }

    if (r) {
	m->m_mem[result].typ = NFR_TYPE_RECORDER;
	m->m_mem[result].val.v = (void *)r;	
    } else {
	m->m_mem[result].typ = NFR_TYPE_ERROR;
	m->m_mem[result].val.v = NFR_ERR_ARGUMENT;
    }
}
