/*
** Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
** All rights reserved.
**
** Use and distribution of this software and its source code
** are governed by the terms and conditions of the
** Network Flight Recorder Software License ("LICENSE.TXT")
*/


#include "nfrd.h"

/*
** scopes.
**
** returns a list of scopes... but only scopes which have
** some global state...
**
** A single parameter, or none... single parameter, a string
** to match scope names against.
** 
**
**
** scopes( matchString );
**
*/

typedef struct scopeState {
    char *	ss_pattern;
    regex_t	ss_regex;
    MemVal *	ss_list;
} scopeState_t;

/*
** Add another scope name of the scopeState, iff it matches the pattern.
*/

addNotherScope( m, rock, info )
Map * m;
void * rock;
char * info;
{
    scopeState_t * ss = (scopeState_t *)rock;
    if ((ss->ss_pattern == 0)
    ||  ((regexec( &ss->ss_regex, m->m_name, 0, 0, 0 ) == 0)) ) {

	ListMem * np = (ListMem *)tmpcalloc( sizeof(*np) );
	np->next = (ListMem *)ss->ss_list->val.v;
	ss->ss_list->val.v = np;
	np->data.typ = NFR_TYPE_STR;
	np->data.val.c = tmpstrdup(m->m_name);
    }
}

void
nfr_blt_scopes(Machine *m,int argc,int firstarg,int result)
{
    scopeState_t ss;

    ss.ss_pattern = 0;
    ss.ss_list = 0;

    if ((argc == 1) && ( m->m_mem[firstarg].typ != NFR_TYPE_STR))  {
	userError: 
	m->m_mem[result].typ = NFR_TYPE_ERR;
	m->m_mem[result].val.i = NFR_ERR_USER;
	return;
    }
    if (argc == 1) {
	ss.ss_pattern = m->m_mem[result].val.c;
	if (regcomp( &ss.ss_regex, ss.ss_pattern, REG_EXTENDED|REG_NOSUB )) {
	    goto userError;
	}
    }

    ss.ss_list = memTmpNew( NFR_TYPE_LIST, 0 );
    if (globalMapBag) {
	mapBagIterate( globalMapBag, addNotherScope, &ss, 0 );
    }

    m->m_mem[result] = *ss.ss_list;
    return;
}

/*
** return the name of the current scope.
**
*/


void
nfr_blt_scope(Machine *m,int argc,int firstarg,int result)
{
    char * scope = tmpstrdup( runCurrentGet()->f_scope );
    m->m_mem[result] = *memTmpNew( NFR_TYPE_STR, scope );

    return;
}
