/*
** Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
** All rights reserved.
**
** Use and distribution of this software and its source code
** are governed by the terms and conditions of the
** Network Flight Recorder Software License ("LICENSE.TXT")
*/

/*
** Since the nfrd has some of the tools we need to build the
** control interface, it makes sense to place it here, with the
** nfrd.
*/
#include "nfrd.h"

/*
** our own trivial buffering scheme, so we don't
** get stuck reading...
*/

buff_t *
buffNew( data, len ) 
char *	data;
int	len;
{
    buff_t * b = (buff_t *)malloc( sizeof(*b) );
    if (b == 0) {
	return(0);
    }
    if ( (b->b_data = data) == 0) {
	b->b_data = (char *)malloc( len );
    }
    b->b_len = 0;
    b->b_loc = 0;
    b->b_size = len;
    return(b);
}

/*
**
*/

void
buffFree( buff_t * b )
{
    if (b->b_data) {
	free(b->b_data);
	b->b_data = 0;
    }
    free(b);
}


/*
**
*/

getcBuff( b )
buff_t * b;
{
    if (b->b_loc <= b->b_len) {
	return(b->b_data[b->b_loc++]);
    } else {
	return(-1);
    }
}

/*
** look to see if there's another line in the buffer.
** if there isn't, and there's data, then move the
** data to the front of the buffer, and wait for more
** data...
*/
char *
getsBuff( b )
buff_t * b;
{
    {
	int c;
	int i;
	for ( i = b->b_loc; i < b->b_len ; ++i ) {
	    if (b->b_data[i] == '\n') {
		int r = b->b_loc;
		b->b_data[i] = 0;
		b->b_loc = i+1;
		return( &b->b_data[r] );
	    }
	}
    }
    {
	/*
	** move stuff to the front of the buffer
	*/
	if (b->b_loc) {
	    int d = (b->b_len - b->b_loc);
	    memcpy( b->b_data, &b->b_data[b->b_loc], d );
	    b->b_loc = 0;
	    b->b_len = d;
	}
    }
    return(0);
}

/*
** fill the buffer with more data from the fd.
*/
fillBuff( b, fd )
buff_t * b;
int fd;
{
    /* first normalize the buffer. */
    if (b->b_loc) {
	int d = (b->b_len - b->b_loc);
	memcpy( b->b_data, &b->b_data[b->b_loc], d );
	b->b_loc = 0;
	b->b_len = d;
    }

    /* fill the end of the buffer */
    {
    int d = (b->b_size - b->b_len);
    int l;

    if (d == 0) {
	/* buffer's too small to get a newline :^o */
    }

    if ((l = read( fd, &b->b_data[b->b_len], d )) > 0) {
	b->b_len += l;
    } else {
	return(-1);	/* no more data. */
    }
    if (l == d) {
	/* there could be more to read */
	return(1);
    }
    return(0);
    }
}
