/*
** Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
** All rights reserved.
**
** Use and distribution of this software and its source code
** are governed by the terms and conditions of the
** Network Flight Recorder Software License ("LICENSE.TXT")
*/


#include <stddef.h>
#include <stdio.h>

#include "nfrd.h"


/*
**
**    Here be file stuff.
**		michael stolarchuk
**
*/


/*
** fileType
**
** Return a single character describing the type of the file.
** Many of these types are traditional unix file types.
*/

int
fileType( path )
char * path;
{
    struct stat s[1];
    char type = 'x';

    if (stat( path, s ) < 0) {
	/*
	** we return one odd character ('x') to indicate we had problems.
	*/
    } else {
	switch ( s->st_mode & S_IFMT ) {
	    case S_IFIFO:
		type = 'f';
		break;
	    case S_IFCHR:
		type = 'c';
		break;
	    case S_IFDIR:
		type = 'd';
		break;
	    case S_IFBLK:
		type = 'b';
		break;
	    case S_IFREG:
		type = '-';
		break;
	    case S_IFLNK:
		type = 'l';
		break;
	    case S_IFSOCK:
		type = 's';
		break;
	}
    }
    return(type);
}
