/*
** Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
** All rights reserved.
**
** Use and distribution of this software and its source code
** are governed by the terms and conditions of the
** Network Flight Recorder Software License ("LICENSE.TXT")
*/

/* 
**
** interface header file.
**
** Seems silly to isolate pcap... but then again,
**
*/


typedef struct intf {
    char *		i_name;		/* name of the thing opened */
    pcap_t	*	i_in;		/* interface file descriptor */
    int			i_pkts;		/* number of packets */
    counter		i_bytes;	/* number of bytes read */
    struct pcap_stat 	i_stat[1];	/* last time we looked. */
    timeval_t		i_arr;		/* last packet arrival time. */
    timeval_t		i_arrDiff;	/* sum of the differences */
    double		i_arrSumSq;	/* sum of squares of arrivDiff */
    double		i_arrStdDev;	/* stdDev of arrival rate */
} intf_t ;

#define	intf_fd(v)	(pcap_fileno((pcap_t *)v))

que_t * intfList;
