/*
** Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
** All rights reserved.
**
** Use and distribution of this software and its source code
** are governed by the terms and conditions of the
** Network Flight Recorder Software License ("LICENSE.TXT")
*/

#include "autopickle.c"

/*
** pickler.
*/

/*
** This piece of code pickles MemVals.
*/


struct pickleMemVal {
    int	pm_nfr;					/* nfrd internal type number */
    int	(*pm_pickle)(FILE *, MemVal * m);	/* associated pickler. */
} pickleMemVal[] = {

	NFR_TYPE_INT,		basicIntPickle,
	NFR_TYPE_STR,		basicStrPickle,
	NFR_TYPE_LIST,		basicListPickle,
	NFR_TYPE_RECORDER,	basicRecorderPickle,
	NFR_TYPE_SCHEMADATA,	basicSchemaDataPickle,
	NFR_TYPE_IPV4HOST,	basicIpv4HostPickle,
	NFR_TYPE_IPV4NET,	basicIpv4NetPickle,
	NFR_TYPE_BLOB,		basicBlobPickle,

};

int
pickle( FILE * f, MemVal * m )
{
    int i;
    int e = sizeof(pickleMemVal)/sizeof(pickleMemVal[0]);

    for (i=0; i<e; ++i) {
	if (m->typ == pickleMemVal[i].pm_nfr) {
		return (*pickleMemVal[i].pm_pickle)( f, m );
	}
    }
    return(0);
}
