/*
** Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
** All rights reserved.
**
** Use and distribution of this software and its source code
** are governed by the terms and conditions of the
** Network Flight Recorder Software License ("LICENSE.TXT")
*/

#include <stdio.h>
#include <signal.h>

char * codeFile;

/*
** These are commands which are run by the nfrd engine
** as part of a recorder.  If we exit, then the engine
** will try to restart the recorder.... that won't help.
** so instead, we just sit still till the regression
** script discovers the success or fail file, and
** stops the test.
*/


fail( file, code )
char * file;
{
    FILE * out = fopen( file, "w" );
    fprintf( out, "%d\n", code );
    fclose(out);
}

success( file )
char * file;
{
    fail( file, 0 );
}

void
failure( sig )
int sig;
{
    fail( codeFile, sig );
}


main( argc, argv )
int argc;
char * argv[];
{
    /*
    ** process the arguments.
    */
    {
	int i;
	for (i = 0; i < argc; ++i ) {
	    if (argv[i][0] == '-') {
		switch (argv[i][1]) {
		    default:
		    usage:
			fprintf( stderr, "%s: usage: file-when-suceeded\n",
				argv[0] );
		}
	    } else {
		codeFile = argv[i];
	    }
	}
    }


    {
	int schemaUnique;
	int cnt = 5;
	signal( SIGALRM, failure );
	alarm(180);	/* if we don't get an answer in 180 seconds, we failed. */

	while (read(0,&schemaUnique,sizeof(int)) == sizeof(int)) {
	    if (schemaUnique == 57007) {
		int integer;
		read(0,&integer,sizeof(integer));
		if (cnt-- < 0) {
		    success( codeFile );
		}
	    } else {
		/* should be the recorder's schema. */
	    }
	    fflush(stderr);
	}
    }
}
