/*
** Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
** All rights reserved.
**
** Use and distribution of this software and its source code
** are governed by the terms and conditions of the
** Network Flight Recorder Software License ("LICENSE.TXT")
*/


#include <stddef.h>
#include <stdio.h>

#include "nfrd.h"

typedef struct dirent direct_t;

/*
**
**    Here be stuff, you can get other places.
**		michael stolarchuk
**
*/

int
nfrAlphasort( const void *d1, const void *d2 )
{
    direct_t *da = *(direct_t **)d1, *db = *(direct_t **)d2;
    return( strcmp( da->d_name, db->d_name ) );
}

/*
** nfrDirentCopy.
** On some systems, you've gotta do more.
** On the systems where it matters, DIR_COPY_NAME
** points to nfrDirentCopy.  Look in the include
** files.
*/

nfrDirentCopy( n, e )
direct_t *n;
direct_t *e;
{
    strncpy( n->d_name, e->d_name, DIR_NAME_MAX );
    *(n->d_name + DIR_NAME_MAX) = 0;
}


nfrScandir( d, list, select, compare  )
char * d;
direct_t *** list;
int (*select)(direct_t *);
int (*compare)( const void *, const void * );
{
    DIR * dir = opendir( d );
    if (dir == 0) {
	return(-1);
    } else {
	int lMax = 128;
	int lNdx = 0;
	direct_t ** l = calloc( lMax, sizeof(*l) );
	direct_t * e;
	/*
	** scan the directory, passing entries to select.  If it
	** says to take it, add it to the list.  Realloc if
	** necessary.
	*/
	while (e = readdir( dir )) {
	    if ((select == 0) || (*select)(e)) {
		direct_t * n = (direct_t *)malloc( sizeof(*n) + 
                                DIR_NAME_MAX + 1);
		DIR_COPY_ENTRY( n, e );

		if (lNdx >= lMax) {
		    lMax += 128;
		    l = (direct_t **)realloc( l, lMax * sizeof(*l) );
		}
		l[lNdx++] = n;
	    }
	}
	closedir(dir);


	/*
	** compute the count, qsort, return the count.
	*/
	qsort( l, lNdx, sizeof(*l), compare );
	*list = l;
	return(lNdx);
    }
}
