/*
** Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
** All rights reserved.
**
** Use and distribution of this software and its source code
** are governed by the terms and conditions of the
** Network Flight Recorder Software License ("LICENSE.TXT")
*/

/*
** configuration routines...
**
** This file needs to be system dependent...
**
*/
#include "nfrd.h"

extern char * argv0;

int
getMaxFds()
{
    static int maxFds = 0;
    
    if (maxFds == 0) {

	maxFds = sysconf(_SC_OPEN_MAX);
#ifdef RLIMIT_NOFILE
	{
	    struct rlimit rlimit;
	    int err = getrlimit( RLIMIT_NOFILE, &rlimit );
	    if ((err = setrlimit( RLIMIT_NOFILE, &rlimit )) < 0) {
		uiCurrPrintf( "%s: can't get number of file descriptor: %s\n",
			argv0, strerror(errno) );
	    } else {
		rlimit.rlim_cur = rlimit.rlim_max;

		if ((err = setrlimit( RLIMIT_NOFILE, &rlimit )) < 0) {
		    uiCurrPrintf( "%s: can't extend number of file descriptors: %s\n",
			argv0, strerror(errno) );
		    uiCurrPrintf( "%s: max file descriptors %d.\n",
			argv0, sysconf(_SC_OPEN_MAX) );
		}
	    }
	    maxFds = rlimit.rlim_cur;
	}
#endif /* RLIMIT_NOFILE */
    }

    return(maxFds);
}
