#include <string.h>

int isspace();

/*
** itoa()
**
** Convert an integer to its ascii representation
*/

char *itoa(int n)
{
    static char str[20];

    register int i, j, c;
    int sign;
        
    if ((sign = n) < 0) 
        n = -n;

    i = 0;
    do {
        str[i++] = n % 10 + '0';
    } while ((n /= 10) > 0);

    if (sign < 0)
        str[i++] = '-';
    str[i] = '\0';

    for (i = 0, j = strlen(str)-1; i < j; i++,j--) {
        c = str[i];
        str[i] = str[j];
        str[j] = c;
    }
    return(str);
}

/*
** blankline()
**
** Determine if the line supplied is a blank line.
*/

int blankline(char *bl_line)   /* Return 1 if blank and 0 otherwise */
{
     register char *blcp;

     for (blcp = bl_line; *blcp; blcp++) {
        if (!isspace(*blcp))
            return (0);
     }   
     return(1);
}

/*
** spacestrip()
**
** Strip spaces from front and back of string 
*/

char *spacestrip(char *str)
{
   char *sp;
   char *rp;

   sp = str;
   rp = str+(strlen(str)-1);

   while (isspace(*sp) && sp != rp)
          sp++;

   if (sp != rp) {
       while (isspace(*rp))
              rp--;
       *(rp+1) = '\0';
   }

   return(sp);
}
