/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   restest.c
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

#include "sys-include.h"
#include "libnfr.h"
#include "nfr_res.h"

int main(int argc, char **argv)
{
  PAlertRes pAlertRes = NULL;
  char *String = NULL;
  int i = 0;

  if( *(argv[++i]) == 'a')
    {
      while (++i < argc)
	{
	  pAlertRes = AlertRes_Open(strtoul(argv[i], NULL, 0));
	  printf("ResId: %s\nResNo: %ld\nText: %s\nSeverity: %#.8lx\n\n",
		 pAlertRes->Id,
		 ResCode_GetResNo(pAlertRes->ResCode),
		 pAlertRes->Text, 
		 ResCode_GetAlertSev(pAlertRes->ResCode));
	  AlertRes_Close(pAlertRes);
	}
    }
  else if ( *(argv[i]) == 's')
    {
      while (++i < argc)
	{
	  String = StringRes_Build(strtoul(argv[i], NULL, 0), 
				   "STR1", "STR2", "STR3", "STR4", NULL);
	  puts(String);
	  SFree(String);
	}
    }
  SExit(0);
  return 0;			/* shutup cc -Wall */
}
