/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT") 

  File:   send_path.c 
  Author: Kent Landfield <kent@nfr.net>
 
 *****************************************************************************/ 
#include "sys-include.h"

#include "spaceman.h"
#include "archive.h"

char *strcpy();
extern char *optarg;
extern int optind, opterr, optopt;

char *Fifopath = SPACEMAN_FIFO;

int send_path(Irec)
    struct indx_rec *Irec;
{
    int fd;                      /* File descriptor        */
    int sendlen;                 /* length of message to send */

    if ((fd = open(Fifopath,O_WRONLY,0666)) == -1) {
       return(-1);
    }

    sendlen = sizeof(struct indx_rec);

    if (write(fd, Irec, (unsigned)sendlen) != sendlen) {
        (void) close(fd);
        return(-1);
    }
    (void) close(fd);
    return(sendlen);
}

int debug = 0;
int verbose = 0;

int main(int argc, char **argv)
{
   int getopt();

   int c;
   struct indx_rec Irec;

   opterr = 0;

   if (argc > 1) {
      while ((c = getopt(argc, argv, "dv")) != EOF) {
         switch (c) {
             case 'd': /* debugging stuff */
                 debug = 1;
                 break;
             case 'v': /* verbose output */
                 verbose = 1;
                 break;
            default : 
                fprintf(stderr,"usage: %s [-dv]\n", argv[0]);
                return(1);
         }
      }
   }

   strcpy(Irec.backend, "webwatcher/webwatcher");
   strcpy(Irec.ctype, "cp");
   strcpy(Irec.path, "data/webwatcher/webwatcher/1997/09/21/21_51_08");
   Irec.starttime = 874896668;

   c = send_path(&Irec);
   printf("send_path returned %d\n", c);

   return(0);       /* terminate this process */
}
