//  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
//  All rights reserved.
//
//  Use and distribution of this software and its source code
//  are governed by the terms and conditions of the
//  Network Flight Recorder Software License ("LICENSE.TXT")
//
//  File:   RollPanel.java
//  Author: Eric Wall <eric@nfr.net>
//



import java.awt.*;

import nfr.misc.*;



public class RollPanel extends Panel {



  public Label rollSize;
  public TextField rsValField;
  public CheckboxGroup rsCBG;
  public Checkbox rsCB1, rsCB2;
  
  public Label rollTime;
  public TextField rtValField;
  public CheckboxGroup rtCBG;
  public Checkbox rtCB1, rtCB2;
  
  public Label archivePathLabel;
  public TextField archivePathField;

  public int cfversion;
  Cf st;
  
  
  
  public RollPanel() {



    setLayout(new GridBagLayout());
    st = new Cf(NFRInfo.document_base,"etc/javastrings/RollPanel.str");
    st.Read();
    
    // Archive Path
    archivePathLabel = new Label(st.textorname("archivePath"));
    gbadd(this,archivePathLabel,0,1,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.1,0.1,20,5,5,5);
    
    archivePathField = new TextField(40);
    gbadd(this,archivePathField,1,1,GridBagConstraints.REMAINDER,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.1,0.1,20,5,5,5);
    
    // Rollover Size
    rollSize = new Label(st.textorname("rollSize"));
    gbadd(this,rollSize,0,2,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.0,0.0,5,5,5,5);
    
    Panel tmpPanel = new Panel();
    tmpPanel.setLayout(new GridBagLayout());
    
    rsCBG = new CheckboxGroup();
    rsCB1 = new Checkbox(st.textorname("YES"),rsCBG,false);
    rsCB2 = new Checkbox(st.textorname("NO"),rsCBG,false);
    
    gbadd(tmpPanel,rsCB1,0,0,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.WEST,
	  0.1,0.0,0,0,0,0);
    gbadd(tmpPanel,rsCB2,0,1,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.WEST,
	  0.1,0.0,0,0,0,0);
    
    gbadd(this,tmpPanel,1,2,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.0,0.0,5,5,5,5);
    
    rsValField = new TextField(40);
    gbadd(this,rsValField,2,2,GridBagConstraints.RELATIVE,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.9,0.0,5,5,5,5);
    
    // Rollover Time
    rollTime = new Label(st.textorname("rollTime"));
    gbadd(this,rollTime,0,3,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.0,0.0,5,5,5,5);
    
    tmpPanel = new Panel();
    tmpPanel.setLayout(new GridBagLayout());
    
    rtCBG = new CheckboxGroup();
    rtCB1 = new Checkbox(st.textorname("YES"),rtCBG,false);
    rtCB2 = new Checkbox(st.textorname("NO"),rtCBG,false);
    
    gbadd(tmpPanel,rtCB1,0,0,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.WEST,
	  0.1,0.0,0,0,0,0);
    gbadd(tmpPanel,rtCB2,0,1,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.WEST,
	  0.1,0.0,0,0,0,0);
    
    gbadd(this,tmpPanel,1,3,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.0,0.9,5,5,5,5);
    
    rtValField = new TextField(40);
    gbadd(this,rtValField,2,3,GridBagConstraints.RELATIVE,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.9,0.9,5,5,5,5);
  }



  // Wraper function for filling out the GridBagConstraints object
  private void gbadd(Container container, Component component, 
		     int grid_x, int grid_y, int grid_width, int
                     grid_height,
		     int fill, int anchor, double weight_x, double
                     weight_y,
		     int top, int left, int bottom, int right)
  {
    GridBagConstraints c = new GridBagConstraints();
    c.gridx = grid_x; c.gridy = grid_y;
    c.gridwidth = grid_width; c.gridheight = grid_height;
    c.fill = fill; c.anchor = anchor;
    c.weightx = weight_x; c.weighty = weight_y;
    if (top+bottom+left+right > 0)
      c.insets = new Insets(top, left, bottom, right);
    
    ((GridBagLayout)container.getLayout()).setConstraints(component, c);
    container.add(component);
  }



  public boolean action(Event e, Object arg) {
    if ( e.target == rsCB1 ) {
      rsValField.enable(); 
      return(true);
    } else if ( e.target == rsCB2 ) {
      rsValField.disable();
      return(true);
    } else if ( e.target == rtCB1 ) {
      rtValField.enable();
      return(true);
    } else if ( e.target == rtCB2 ) {
      rtValField.disable();
      return(true);
    }
    // COPY
    
    return false;
  }
  
  
  
  
  
  public static void main(String[] args) {
    System.out.println("RollPanel.class");
  }
}

