//  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
//  All rights reserved.
//
//  Use and distribution of this software and its source code
//  are governed by the terms and conditions of the
//  Network Flight Recorder Software License ("LICENSE.TXT")
//

// test class
import java.applet.*;
import java.awt.*;

import nfr.misc.*;
import nfr.rc.*;
import nfr.alerts.*;
import nfr.facilities.*;


class Threader implements Runnable
{
  Meter dm = null;
  Meter bm = null;
  Meter adm = null;
  Meter abm = null;
  Meter ddm = null;
  Meter cbm = null;
  Meter lcbm = null;
  int max = 0;

  public Threader(int max, Meter dm, Meter bm, Meter adm, Meter abm, 
		  Meter ddm, Meter cbm, Meter lcbm)
  {
    this.dm = dm;
    this.bm = bm;
    this.adm = adm;
    this.abm = abm;
    this.ddm = ddm;
    this.cbm = cbm;
    this.lcbm = lcbm;
    this.max= max;
  }

public void run()
  {
    dm.reset();
    bm.reset();
    adm.reset();
    abm.reset();
    ddm.reset();
    cbm.reset();
    int i = 0;
    while(i <= max)
      {
	dm.set_value(i);
	bm.set_value(i);
	adm.set_value(i);
	abm.set_value(i);
	ddm.set_value(i);
	cbm.set_value(i);
	lcbm.set_value(i);
	try { Thread.sleep(10); }
	catch(InterruptedException X) { System.out.println(X); }
	i++;
      }

    while(i >= 0)
      {
	dm.set_value(i);
	bm.set_value(i);
	adm.set_value(i);
	abm.set_value(i);
	ddm.set_value(i);
	cbm.set_value(i);
	lcbm.set_value(i);
	i--;
      }
  }
}


public class TestApplet extends Applet implements ResConsts
{
  FacEditor F = null;
  DigitalMeter dm = null;
  BarMeter bm = null;
  DigitalMeter adm = null;
  BarMeter abm = null;
  DigitalMeter ddm = null;
  ColoredBarMeter cbm = null;
  ColoredBarMeter lcbm = null;
  Thread thd = null;
  int max = 0;
  Label mLabel = null;

public void init()
  {
    NFRInfo.setup(this);
    // now do whatever
    test8();
    //Thread t = new Thread(new Threader());
    //t.start();
  }

public void start()
  {
  }

public boolean action(Event e, Object arg) 
  {
    return action7(e,arg);
  }

public void test8()
  {
	Frame f = new Frame();
	f.resize(200,300);
	f.show();
  }


public void test7()
  {
    bm = new BarMeter(false, Meter.FIXED_MAX);
    bm.set_size(new Dimension(CtoP.Width(19,this),
			      CtoP.Height(1,this)));
    add(bm);
    add(new Button("dance"));
    add(new Button("stop"));
  }

public boolean action7(Event e, Object arg) 
  {
    if(arg == "dance")
      {
	bm.startDancing();
	return true;
      }
    if(arg == "stop")
      {
	bm.stopDancing();
	return true;
      }
    return false;
  }
/********
public void test6()
  {
    SortView sv = new SortView(300,300);
    sv.addView("one", new ListView());
    sv.addView("two", new ListView());
    sv.addView("three", new ListView());
    add(sv);
    sv.resize(300,400);
  }

public void test5()
  {
    GridLayout l = new GridLayout(0,2);
    setLayout(l);
    add(new Label("DigitalMeter (max = 500"));
    dm = new DigitalMeter(false, Meter.FIXED_MAX);
    dm.set_units("frobnai");
    dm.set_max(500);
    dm.set_showPercentage(true);
    dm.set_showMax(true);
    add(dm);

    add(new Label("BarMeter (max = 500)"));
    bm = new BarMeter(false, Meter.FIXED_MAX);
    bm.set_max(500);
    add(bm);

    add(new Label("DigitalMeter (adaptive, initial max = 500"));
    adm = new DigitalMeter(false, Meter.ADAPTIVE_MAX);
    adm.set_units("flodgets");
    adm.set_max(500);
    adm.set_showPercentage(true);
    adm.set_showMax(true);
    add(adm);

    add(new Label("BarMeter (adaptive, initial max = 500)"));
    abm = new BarMeter(false, Meter.ADAPTIVE_MAX);
    abm.set_max(500);
    add(abm);

    add(new Label("DigitalMeter (max = 1000"));
    ddm = new DigitalMeter(false, Meter.FIXED_MAX);
    ddm.set_units("cubits");
    ddm.set_max(1000);
    ddm.set_showPercentage(true);
    ddm.set_showMax(true);
    add(ddm);

    add(new Label("ColoredBarMeter (max = 1000)"));
    cbm = new ColoredBarMeter(false, Meter.FIXED_MAX);
    cbm.set_colorAt(0, Color.blue);
    cbm.set_colorAt(500, Color.green);
    cbm.set_colorAt(750, Color.yellow);
    cbm.set_colorAt(950, Color.red);
    add(cbm);
    cbm.set_max(1000);

    add(new Label("ColoredBarMeter (logarithmic, max = 1000)"));
    lcbm = new ColoredBarMeter(true, Meter.FIXED_MAX);
    lcbm.set_colorAt(0, Color.blue);
    lcbm.set_colorAt(500, Color.green);
    lcbm.set_colorAt(750, Color.yellow);
    lcbm.set_colorAt(950, Color.red);
    add(lcbm);
    lcbm.set_max(1000);

    add(new Button("go"));
  }

public boolean action5(Event e, Object arg) 
  {
    if("go".equals(arg))
      {
	if(thd != null)
	  {
	    thd.stop();
	    thd = null;
	  }
	if(thd == null)
	  {
	    thd = new Thread(new Threader(1000, dm, bm, adm, abm, ddm,
					  cbm, lcbm));
	    thd.start();
	  }
      }
    return true;
  }

public void test4()
  {
    AlertRes ar = AlertRes.load("supernew_alert", 
				"etc/resources/usr_res.src");
    ar.setText("foooooooo barrrrrrrrrrrrrrrrrr");
    add(ar.getConfigurator());
    ar.save();
  }

public void test3()
  {
    add(new AlertViewer());
  }

public void test1()
  {
    System.out.println(getFont());
    ResTab rt = new ResTab();
    rt.load(getDocumentBase(), "etc/resources/nfr_res.src");
    Frame f = rt.getCfgWindow(this);
    f.show();
  }

public void test2()
  {
    repTile L = new repTile();
    setLayout(L);

    F = FacEditor.getEditor(getDocumentBase(), "NFR_FAC_MAIL");
    add(F);

    L.setConstraints(0,0,0,0,"",F);
    L.setStretchy(0,0);

  }
****/
}
