/*
        Copyright(C) 1997 Network Flight Recorder, Inc.
        All rights reserved.

        Use and distribution of this software and its source code
        are governed by the terms and conditions of the
        Network Flight Recorder Software License ("LICENSE.TXT")

*/

package graph;

import java.awt.*;

//  Bar Graph data class:  a simple list node that stores values for the
//  label, color and value of each bar 

public class BGData {

  private String label;
  private long value;
  private Color color;
  private BGData next;
  private BGData prev;

  public BGData(String label, long value, Color color) {
    this.label = label;
    this.value = value;
    this.color = color;
  }

  public BGData getNext() {
    return next;
  }

  public BGData getPrev() {
    return prev;
  }

  public void setNext (BGData next) {
    this.next = next;
  }

  public void setPrev (BGData prev) {
    this.prev = prev;
  }

  public long getValue() {
    return value;
  }

  public String getLabel() {
    return label;
  }

  public Color getColor() {
    return color;
  }
}
