/*
        Copyright(C) 1997 Network Flight Recorder, Inc.
        All rights reserved.

        Use and distribution of this software and its source code
        are governed by the terms and conditions of the
        Network Flight Recorder Software License ("LICENSE.TXT")

*/

package graph;



import java.io.*;

//  EOFInputStream:  like a DataInputStream, only it throws an EOFException
//  on end of file (in a newly defined "nextline" method)

public class EOFInputStream extends DataInputStream {

  public EOFInputStream (InputStream str) {
    super(str);
  }

  public String nextLine()
       throws java.io.EOFException, java.io.IOException
  {
    String line = readLine();
    if (line == null)
      throw new java.io.EOFException();
    else
      return line;
  }
}

