/*
        Copyright(C) 1997 Network Flight Recorder, Inc.
        All rights reserved.

        Use and distribution of this software and its source code
        are governed by the terms and conditions of the
        Network Flight Recorder Software License ("LICENSE.TXT")

*/

package graph;
import java.awt.*;

public class View extends java.awt.Frame
{

	Viewer v;
	nfr.misc.repTile r;
	java.awt.Button button;
	java.awt.Frame f;

public View ( java.lang.String ty, java.net.URL ur, java.lang.String title,
	java.lang.String closelabel)
	{
	f = this;
	f.setTitle(title);

	r = new nfr.misc.repTile();
	f.setLayout(r);

	if (ty.equals("b"))
		v = new BarGraphViewer(ur);
	else if (ty.equals("p"))
		v = new PieViewer(ur);
	else if (ty.equals("s"))
		v = new ScatterViewer(ur);
	else
		{
		System.out.println("bad arg to graph.View");
		return;
		}

 	r.setStretchy(0,0);
	f.add(v);
	r.setConstraints(0,0,0,0,"",v);
	button = new java.awt.Button(closelabel);
	f.add(button);
	r.setConstraints(1,0,1,0,"ch",button);

	f.resize(500, 500);

	// pack();

	v.init();

	if (v.is_dead)
		{
		System.out.println("v is dead!");
		this.destroy_parent();
		return;
		}

	if (v.graph != null)
		v.start();

	f.show();

	// apparently it is a bad idea to call the run function
	// after you call the start function...  I'm not quite sure
	// what he was trying to do here.

 	// v.run();
	}


/****
* if close button hit, we walk up to the top level frame and
* delete it.
*/
        public void destroy_parent() {
                java.awt.Component c;
                c=f;
                while ( (c != null) && (! (c instanceof java.awt.Frame)) )
                        c= c.getParent();
                if (c != null)
                        ((java.awt.Frame)c).dispose();
        }


        public boolean handleEvent (java.awt.Event e) 
	{
		if ((e.id==java.awt.Event.ACTION_EVENT) && (e.target==button))
		{
			destroy_parent();
			return true;
		} 
		return false;
	}

	public void resize (java.awt.Dimension d)
	{
		super.resize(d);
System.out.println("View resize D "+d.toString());
	}

	public void resize ( int x, int y)
	{
		super.resize(x,y);
System.out.println("View resize int "+x+" "+y);
		// r.layoutContainer(this);
	}

	public void reshape ( int x, int y, int w , int h )
	{
		super.reshape(x,y,w,h);
System.out.println("View reshape "+x+" "+y+" "+w+" "+h);
		// r.layoutContainer(this);
	}

}
