/*
        Copyright(C) 1997 Network Flight Recorder, Inc.
        All rights reserved.

        Use and distribution of this software and its source code
        are governed by the terms and conditions of the
        Network Flight Recorder Software License ("LICENSE.TXT")

*/

package graph;


import java.awt.*;
import nfr.misc.*;

// ViewPanel:  a panel that contains our principle graph
// components.  the panel passes its resize along to
// some of it's member components

class ViewPanel extends Panel {

  private Canvas title;
  private Canvas display;
  private Graph graph;

  repTile r;

  ViewPanel(Graph graph,
	    Canvas title, 
	    Canvas display, 
	    Scrollbar hscroll,
	    Scrollbar vscroll) {

    // borderlayout is the layout manager
    // setLayout(new BorderLayout());
    r = new repTile();
    setLayout(r);

    this.graph = graph;

    this.title = title;
    add(title);
    r.setConstraints(0,0,0,2,"",title);

    if (hscroll != null)
	{
	add(hscroll);
	r.setConstraints(2,1,2,1,"",hscroll);
	}
    if (vscroll != null)
	{
	add(vscroll);
	r.setConstraints(1,0,1,0,"",vscroll);
	}

    this.display = display;
    add(display);
    r.setConstraints(1,1,1,1,"",display);
    r.setStretchy(1,1);
  }

  // on reshape, we may have changed our scroll params
  public void reshape(int x, int y, int w, int h) {
    super.reshape(x, y, w, h);

    display.repaint();
  }

}


