//  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
//  All rights reserved.
//
//  Use and distribution of this software and its source code
//  are governed by the terms and conditions of the
//  Network Flight Recorder Software License ("LICENSE.TXT")
//
//  File:   FacEditWin.java 
//  Author: Eric Wall <eric@nfr.net>
//


package nfr.facilities;

import java.awt.*;
import java.util.*;
import java.net.*;
import java.io.*;

import nfr.misc.*;
import nfr.rc.*;

public class FacEditWin extends GoodFrame
{
  FacEditor mEditor = null;
  Button mSaveBtn = null;
  Button mReloadBtn = null;
  Button mCancelBtn = null;
  FacId mFid = null;

// HEY_ERIC: this is a stupid dummy function that you should fill with
// code to create the facility on the server
  //private String createFacility(String id, String type)
  //{
  //}

public FacEditWin(FacId fid, Window w)
  {
    super((Component)w);

    mFid = fid;

    dbg.out("in FacEditWin() id = " + fid.getId(), 0);
    repTile l = new repTile();
    setLayout(l);

    String ErrMsg = null;

    // try to create the facility if it's a new one:
    //if(fid.getState() == ResConsts.RESID_STATE_ADDED)
    //ErrMsg = createFacility(fid.getId(), fid.getGuiType());
    
    mEditor = FacEditor.getEditor(NFRInfo.document_base, fid.getId());
    if(mEditor == null)
      ErrMsg = "Can't create editor";
    
    if(ErrMsg != null)
      {
	// something's hosed, so we turn the Frame into an error dialog
	setTitle("Error");
	Label lbl = new Label("Can't create facility: " + fid.getId());
	add(lbl);
	l.setConstraints(0,0,0,0,"ch",lbl);
	lbl = new Label("reason: " + ErrMsg);
	add(lbl);
	l.setConstraints(1,0,1,0,"ch",lbl);
	lbl = new Label("");
	add(lbl); // spacer
	l.setConstraints(2,0,2,0,"ch",lbl);
	
	// make the mCancelBtn say Ok in this case
	add(mCancelBtn = new Button("Ok"));
	l.setConstraints(3,0,3,0,"ch",mCancelBtn);
	l.setborder(CtoP.Width(3, this), CtoP.Width(3, this),
		    CtoP.Height(1, this), CtoP.Height(1, this));
	l.setStretchy(0,0);
	int width = ErrMsg.length() + 8;
	if(width < 55)
	  width = 55;
	resize(CtoP.Width(width, this), CtoP.Height(12, this));
	return;
      }
    
    // if we get to here then we know we've got a valid facility
    add(mEditor);
    l.setConstraints(0,0,0,0,"",mEditor);

    Panel btnPnl = new Panel();
    btnPnl.add(mSaveBtn = new Button("OK"));
    btnPnl.add(mReloadBtn = new Button("Reset"));
    btnPnl.add(mCancelBtn = new Button("Cancel"));
    add(btnPnl);
    l.setConstraints(1,0,1,0,"ch",btnPnl);
    
    l.setStretchy(0,0);
    //resize(CtoP.Width(70, this), CtoP.Height(28, this));
    resize(480,560);
    setTitle("Properties: " + mFid.getDispName());
}

public boolean action(Event e, Object arg)
  {
    if(e.target == mSaveBtn)
      {
	if(!mEditor.Merge())
	  MsgBox.show("Error", "save properties failed");
	else
	  {
	    MsgBox.show("Ok", "properties saved");
	    dispose();
	  }
	return true;
      }
    else if(e.target == mReloadBtn)
      {
	mEditor.Reload();
	return true;
      }
    else if(e.target == mCancelBtn)
      {
	dispose();
	return true;
      }
    else
      return false;
  }

}
