//  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
//  All rights reserved.
//
//  Use and distribution of this software and its source code
//  are governed by the terms and conditions of the
//  Network Flight Recorder Software License ("LICENSE.TXT")
//
//  File:   FaxEditor.java 
//  Author: Eric Wall <eric@nfr.net>
//

package nfr.facilities;

// base class for panels that display and update cf files

import java.awt.*;
import java.util.*;
import java.net.*;

import nfr.misc.*;

public class FaxEditor extends FacEditor
{

  Cf mCf;
  Label faxnumLabel, recipLabel, regardLabel, companyLabel, cmntsLabel;
  Label fTimeLabel, fCountLabel, fMethodLabel;
  TextField faxnumField, recipField, regardField, companyField, cmntsField;
  TextField fTimeField, fCountField;
  //fMethodField;

  public FaxEditor(Cf guiCf, URL BaseURL, String Path) 
  {
    String value;
    String goodLabel;

    // Set layout manager and read queue.cf file
    this.setLayout(new GridBagLayout());
    mCf=new Cf(BaseURL, Path);
    mCf.Read();

    // FaxNum
    goodLabel = (String) guiCf.get("FaxNum");
    if((goodLabel == null) || (goodLabel.equals(""))) {
      faxnumLabel = new Label("FaxNum");
    } else {
      faxnumLabel = new Label(goodLabel);
    }
    gbadd(this,faxnumLabel,0,0,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.0,0.0,5,5,5,5);

    value = (String) mCf.get("FaxNum");
    faxnumField = new TextField(value, 30);
    gbadd(this,faxnumField,1,0,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.0,0.0,5,5,5,5);

     
    // Recipient
    goodLabel = (String) guiCf.get("Recipient");
    if((goodLabel == null) || (goodLabel.equals(""))) {
      recipLabel = new Label("Recipient");
    } else {
      recipLabel = new Label(goodLabel);
    }
    gbadd(this,recipLabel,0,1,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.0,0.0,5,5,5,5);

    value = (String) mCf.get("Recipient");
    recipField = new TextField(value, 30);
    gbadd(this,recipField,1,1,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.0,0.0,5,5,5,5);
    
    // Regarding
    goodLabel = (String) guiCf.get("Regarding");
    if((goodLabel == null) || (goodLabel.equals(""))) {
      regardLabel = new Label("FaxNum");
    } else {
      regardLabel = new Label(goodLabel);
    }
    gbadd(this,regardLabel,0,2,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.0,0.0,5,5,5,5);

    value = (String) mCf.get("Regarding");
    regardField = new TextField(value, 30);
    gbadd(this,regardField,1,2,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.0,0.0,5,5,5,5);

    
    // Company
    goodLabel = (String) guiCf.get("Company");
    if((goodLabel == null) || (goodLabel.equals(""))) {
      companyLabel = new Label("Company");
    } else {
      companyLabel = new Label(goodLabel);
    }
    gbadd(this,companyLabel,0,3,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.0,0.0,5,5,5,5);

    value = (String) mCf.get("Company");
    companyField = new TextField(value, 30);
    gbadd(this,companyField,1,3,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.0,0.0,5,5,5,5);

    
    // Comments
    goodLabel = (String) guiCf.get("Comments");
    if((goodLabel == null) || (goodLabel.equals(""))) {
      cmntsLabel = new Label("Comments");
    } else {
      cmntsLabel = new Label(goodLabel);
    }
    gbadd(this,cmntsLabel,0,4,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.0,0.0,5,5,5,5);

    value = (String) mCf.get("Comments");
    cmntsField = new TextField(value, 30);
    gbadd(this,cmntsField,1,4,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.0,0.0,5,5,5,5);

    // Flush Time
    goodLabel = (String) guiCf.get("Flush_Time");
    if((goodLabel == null) || (goodLabel.equals(""))) {
      fTimeLabel = new Label("Flush_Time");
    } else {
      fTimeLabel = new Label(goodLabel);
    }
    gbadd(this,fTimeLabel,0,5,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.0,0.0,5,5,5,5);

    value = (String) mCf.get("Flush_Time");
    fTimeField = new TextField(value, 30);
    gbadd(this,fTimeField,1,5,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.0,0.0,5,5,5,5);

    // Flush Count
    goodLabel = (String) guiCf.get("Flush_Count");
    if((goodLabel == null) || (goodLabel.equals(""))) {
      fCountLabel = new Label("Flush_Count");
    } else {
      fCountLabel = new Label(goodLabel);
    }
    gbadd(this,fCountLabel,0,6,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.0,0.0,5,5,5,5);
    
    value = (String) mCf.get("Flush_Count");
    fCountField = new TextField(value, 30);
    gbadd(this,fCountField,1,6,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.0,0.0,5,5,5,5);

    /********
      // Flush Method
    goodLabel = (String) guiCf.get("Flush_Method");
    if((goodLabel == null) || (goodLabel.equals(""))) {
      fMethodLabel = new Label("Flush_Method");
    } else {
      fMethodLabel = new Label(goodLabel);
    }
    gbadd(this,fMethodLabel,0,7,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.0,0.1,5,5,5,5);
    
    value = (String) mCf.get("Flush_Method");
    fMethodField = new TextField(value, 30);
    gbadd(this,fMethodField,1,7,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.0,0.1,5,5,5,5);
    *******/
  }

  // Wraper function for filling out the GridBagConstraints object
  private void gbadd(Container container, Component component, 
		     int grid_x, int grid_y, int grid_width, int grid_height,
		     int fill, int anchor, double weight_x, double weight_y,
		     int top, int left, int bottom, int right)
  {
    GridBagConstraints c = new GridBagConstraints();
    c.gridx = grid_x; c.gridy = grid_y;
    c.gridwidth = grid_width; c.gridheight = grid_height;
    c.fill = fill; c.anchor = anchor;
    c.weightx = weight_x; c.weighty = weight_y;
    if (top+bottom+left+right > 0)
      c.insets = new Insets(top, left, bottom, right);
    
    ((GridBagLayout)container.getLayout()).setConstraints(component, c);
    container.add(component);
  }

  public boolean Merge()
  {
    System.out.println("In FaxEditor.Merge() method");

    mCf.put("FaxNum",faxnumField.getText()); 
    mCf.put("Recipient",recipField.getText()); 
    mCf.put("Regarding",regardField.getText()); 
    mCf.put("Company",companyField.getText()); 
    mCf.put("Comments",cmntsField.getText()); 
    mCf.put("Flush_Time",fTimeField.getText());     
    mCf.put("Flush_Count",fCountField.getText());    
    // mCf.put("Flush_Method",fMethodField.getText()); 

    return mCf.Merge();

  }
  
  
  public boolean Reload()
  {
    System.out.println("In FaxEditor.Reload() method");

    mCf.Read();

    faxnumField.setText((String) mCf.get("FaxNum"));
    recipField.setText((String) mCf.get("Recipient"));
    regardField.setText((String) mCf.get("Regarding"));
    companyField.setText((String) mCf.get("Company"));
    cmntsField.setText((String) mCf.get("Comments"));
    fTimeField.setText((String) mCf.get("Flush_Time")); 
    fCountField.setText((String) mCf.get("Flush_Count"));
    // fMethodField.setText((String) mCf.get("Flush_Method"));

    return true;
  }
  
  public static void main(String[] args) {
    System.out.println("FaxEditor.class");
  }
} 

