//  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
//  All rights reserved.
//
//  Use and distribution of this software and its source code
//  are governed by the terms and conditions of the
//  Network Flight Recorder Software License ("LICENSE.TXT")
//
//  File:   LogEditor.java 
//  Author: Eric Wall <eric@nfr.net>
//


package nfr.facilities;

// base class for panels that display and update cf files

import java.awt.*;
import java.util.*;
import java.net.*;

import nfr.misc.*;

public class LogEditor extends FacEditor
{
  public LogEditor(Cf guiCf, URL BaseURL, String Path) 
  {
    this.setLayout(new GridBagLayout());

    Button b = new Button("LogEditor");
    gbadd(this,b,0,0,1,1,
	  GridBagConstraints.NONE,
	  GridBagConstraints.NORTHWEST,
	  0.0,0.0,5,5,5,5);
  }

  // Wraper function for filling out the GridBagConstraints object
  private void gbadd(Container container, Component component, 
		     int grid_x, int grid_y, int grid_width, int grid_height,
		     int fill, int anchor, double weight_x, double weight_y,
		     int top, int left, int bottom, int right)
  {
    GridBagConstraints c = new GridBagConstraints();
    c.gridx = grid_x; c.gridy = grid_y;
    c.gridwidth = grid_width; c.gridheight = grid_height;
    c.fill = fill; c.anchor = anchor;
    c.weightx = weight_x; c.weighty = weight_y;
    if (top+bottom+left+right > 0)
      c.insets = new Insets(top, left, bottom, right);
    
    ((GridBagLayout)container.getLayout()).setConstraints(component, c);
    container.add(component);
  }
  
  public static void main(String[] args) {
    System.out.println("LogEditor.class");
  }
} 

