/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   BarMeter.java
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/


package nfr.misc;

import java.awt.*;


public class BarMeter extends Meter
{

public BarMeter(boolean logarithmic, int max_mode) 
  {
    super(logarithmic, max_mode);
  }

public void draw_contents(Graphics g)
  {
    Dimension d = size();

    if(current <= prev)
      {
	int left = (current * d.width / max) + (border*2);
	int right = d.width - (border*2);
	g.setColor(bg_color);
	g.fillRect(left, border*2,
		   right - left,
		   d.height - (border*4));
      }

    else if (current > prev)
      {
	g.setColor(fg_color);
	g.fillRect(border*2, border*2, 
		   current * (d.width - border*4) / max,
		   d.height - (border*4));
      }
  }
  
public void danceStep(Graphics g)
  {
    Dimension d = size();
    g.setColor(bg_color);
    g.fillRect(border*2, border*2, 
	       d.width - (border*4),
	       d.height - (border*4));
    g.setColor(fg_color);
    g.fillOval(border*2 + (current * (d.width - border*4) / max), border*2, 
	       d.height - (border*4),
	       d.height - (border*4));
	       
  }
/******
public void danceStep(Graphics g)
  {
    Dimension d = size();

    if(current < prev)
      {
	int left = (current * d.width / max) + (border*2);
	int right = d.width - (border*2);
	int lefter = border*2;
	int righter = ((current - danceShoeSize) * d.width / max) + (border*2);
	g.setColor(bg_color);
	g.fillRect(left, border*2,
		   right - left,
		   d.height - (border*4));
	if(righter > 0)
	  {
	    g.fillRect(lefter, border*2,
		       righter - lefter,
		       d.height - (border*4));
	  }
      }

    else if (current > prev)
      {
	g.setColor(bg_color);
	g.fillRect(border*2, border*2, 
		   (current - danceShoeSize) * (d.width - border*4) / max,
		   d.height - (border*4));

	g.setColor(fg_color);
	g.fillRect((current - danceShoeSize) * (d.width - border*4) / max, 
		   border*2, 
		   current * (d.width - border*4) / max,
		   d.height - (border*4));
      }
  }
******/

public Dimension getPreferredSize() 
  {
    if (psize == null)
      {
	psize= new Dimension(CtoP.Width(25,this), CtoP.Height(1,this));
      }

    return psize;
  }
  

}
