/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   CtoP.java
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

package nfr.misc;

import java.awt.*;

public class CtoP
{
  static String s = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";

public static int Width(int numChars, Component c)
  {
    Font f = c.getFont();
    if(f == null)
      f = NFRInfo.font;
    FontMetrics m = c.getFontMetrics(f);
    int width = m.stringWidth(s) / s.length();
    
    if (width <= 0)
      width = 1;
    return width * numChars;
  }

public static int Width(String str, Component c)
  {
    Font f = c.getFont();
    if(f == null)
      f = NFRInfo.font;
    FontMetrics m = c.getFontMetrics(f);
    return m.stringWidth(str);
  }

public static int Height(int numChars, Component c)
  {
    Font f = c.getFont();
    if(f == null)
      f = NFRInfo.font;
    FontMetrics m = c.getFontMetrics(f);
    int height = m.getHeight();
    return height * numChars;
  }

public static Dimension Dim(int hChars, int wChars, Component c)
  {
    Dimension d = new Dimension();
    Font f = c.getFont();
    if(f == null)
      f = NFRInfo.font;
    FontMetrics m = c.getFontMetrics(f);
    int width = m.stringWidth(s) / s.length();
    
    if (width <= 0)
      width = 1;
    int height = m.getHeight();
    d.width = width * wChars;
    d.height = height *hChars;
    return d;
  }

}
