/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   DigitalMeter.java
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

package nfr.misc;

import java.awt.*;


public class DigitalMeter extends Meter
{
  String units = null;
  String separator = null;
  boolean showMax = false;
  boolean showPercentage = false;
  boolean showCurrent = true;

public DigitalMeter(boolean logarithmic, int max_mode) 
  {
    super(logarithmic, max_mode);
    units = new String("");
    separator = new String (" of ");
  }

public final void set_units(String s) { units = s; }

public final void set_separator(String s) { separator = s; }

public final void set_showMax(boolean b) { showMax = b; }

public final void set_showPercentage(boolean b) { showPercentage = b; }

public void draw_contents(Graphics g)
  {
    Dimension d = size();

    g.setColor(bg_color);
    g.fillRect(border*2, border*2, 
	       d.width - (border*4 + 1), 
	       d.height - (border*4 +1));

    g.setColor(fg_color);
    String s = getDispString(currentPercent, current, max);
    g.drawString(s, (d.width / 2) - CtoP.Width(s,this) / 2, 
		 (d.height / 2) + CtoP.Height(1,this) / 4);
  }
  
public Dimension getPreferredSize() 
  {
    if (psize == null)
      {
	String s = getDispString(100, max, max);
	psize= new Dimension(CtoP.Width(s,this) + CtoP.Width(3,this), 
			     CtoP.Height(2,this));
      }

    return psize;
  }
  
public String getDispString(int p, int c, int m)
  {
    StringBuffer sb = new StringBuffer(64);
    if(showPercentage)
      {
	sb.append(String.valueOf(p));
	sb.append("%");
      }
    if(showPercentage && showCurrent)
      {
	sb.append("  -  ");
      }
    if(showCurrent)
      {
	sb.append(String.valueOf(c));
      }
    if(showMax)
      {
	sb.append(separator);
	sb.append(String.valueOf(m));
      }
    sb.append(" ");
    sb.append(units);
    return sb.toString();
  }

}
