//  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
//  All rights reserved.
//
//  Use and distribution of this software and its source code
//  are governed by the terms and conditions of the
//  Network Flight Recorder Software License ("LICENSE.TXT")
//


package nfr.misc;

import java.awt.*;

/*
* linear/log
* max fixed / max of values / decays
*/

public class bar_meter extends Canvas {
	int max, current;
	boolean logarithmic;
	int max_mode;
	Dimension psize;
	static double log2= java.lang.Math.log(2.0);
	int prev_w = 0;

	Color my_color;

	public bar_meter( boolean logarithmic, int max_mode) {
		super();
		this.logarithmic = logarithmic;
		this.max_mode = max_mode;
		max=1;
		my_color = new Color( 0xD00000 );
	}

	public void set_value(int v) {
		current = v;
		repaint();
	}

	public void set_max(int m) {
		max = m;
	}

	public void paint( Graphics g ) {
		Dimension d = size();
		int border = 2;
		int thick = 2;

		g.setColor(my_color);

		d.width = d.width - border - border;
		d.height = d.height - border - border;
		g.draw3DRect(border,border,d.width,d.height,true);
		g.draw3DRect(border+1,border+1,d.width-border,
			d.height-border, true);

		d.width = d.width - thick - thick;
		d.height = d.height - thick - thick;

		int w;
		switch (max_mode)
			{
		case 0:	break;				// fixed max
		case 1:					// only increasing
			if (current > max)
				max = current;
			break;
		case 2:					// adaptive
			max = (max * 9 + current) / 10;
			if (current > max)
				max = current;
			break;
			}

		if (logarithmic)
			{
			double ww = 0;
			if (current > 0)
				ww = java.lang.Math.log(current);
			w = (int)(ww * d.width) / 16;
			}
		else
			{
			w = current * d.width / max;
			}

		int xxx = border+thick;
		g.clearRect(xxx+w,xxx,d.width-xxx-w,d.height+1);
		g.fillRect(xxx,xxx,w+1,d.height+1);
		prev_w = w;
	}

	

	public Dimension preferredSize() {
		if (psize == null)
			psize= new Dimension(40,20);
		return psize;
	}

}

