//  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
//  All rights reserved.
//
//  Use and distribution of this software and its source code
//  are governed by the terms and conditions of the
//  Network Flight Recorder Software License ("LICENSE.TXT")
//


package nfr.misc;

import java.util.Enumeration;

class ordered_table_entry {
	String key;
	Object data;
	ordered_table_entry next;
}

public class ordered_table {
	ordered_table_entry all;

	public ordered_table ( ) {
		all = null;
	}

	public synchronized void put ( String key, Object data ) {
		ordered_table_entry cur = null, prev = null, tmp;
		if (all == null)
			{
			all = new ordered_table_entry();
			all.key = key;
			all.data=data;
			all.next = null;
			return;
			}
		cur = all;
		while (true)
			{
			int n =key.compareTo(cur.key);
			if (n < 0)
				{
				// insert before cur
				tmp = new ordered_table_entry();
				tmp.key =key;
				tmp.data=data;
				tmp.next = cur;
				if (prev == null)
					all=tmp;
				else
					prev.next = tmp;
				return;
				}
			else if (n == 0)
				{
				cur.data=data;
				return;
				}
			else
				{
				if (cur.next == null )
					{
					// add at end
					tmp = new ordered_table_entry();
					tmp.key = key;
					tmp.data=data;
					tmp.next=null;
					cur.next=tmp;
					return;
					}
				else
					{
					prev=cur;
					cur = cur.next;
					}
				}
			}
	}

	public Object get ( String key ) {
		ordered_table_entry cur = null;
		for (cur = all; cur != null ; cur=cur.next)
			{
			if (cur.key.compareTo(key) == 0)
				return cur.data;
			}
		return null;
	}

	public synchronized Enumeration keys () {
		return new ordered_table_enumerator(all);
	}
}

class ordered_table_enumerator implements Enumeration {
	ordered_table_entry where;

	public ordered_table_enumerator ( ordered_table_entry all ) {
		this.where = all;
	}

	public boolean hasMoreElements() {
		return where != null;
	}

	public Object nextElement() {
		if (where == null)
		  return null;
		Object o;
		o=where.key;
		where=where.next;
		return o;
	}
}

