/*
        Copyright(C) 1997 Network Flight Recorder, Inc.
        All rights reserved.

        Use and distribution of this software and its source code
        are governed by the terms and conditions of the
        Network Flight Recorder Software License ("LICENSE.TXT")

By Mark Sienkiewicz / NFR

*/


package nfr.misc;

import java.net.*;
import java.io.*;
import java.util.*;

public class remote_file_io extends Object {

	public static String load_file(java.net.URL docbase, String name){
		String result = "";
		DataInputStream d = null;
		try {
		d = remote_file_io.read_file(docbase, name);
		String s = d.readLine();
		if (s == null)
			throw new IOException(" no first line back ");

		if (s.substring(0,3).compareTo("ok ") != 0)
			{
			System.out.println("remote_file_io.load_file bad first line:"
				+s+":");
			throw new IOException(" didn't get ok ");
			}
		int len = Integer.parseInt(s.substring(3));
		byte [] b = new byte[len];
		d.readFully(b);
		result=new java.lang.String(b,0);
		} catch (Exception e) {
		System.out.println("exception in remote_file_io.load_file: "
			+ e.toString());
		}
		if (d != null)
			try {
				d.close();
			} catch (Exception e) {
				// like I care if you can't close it.
			}
		return result;
	}




	public static DataInputStream read_file( URL docbase, String name) 
		throws  java.io.IOException, java.net.MalformedURLException
		{
		DataInputStream d = null;
		URLConnection conn = new URL(docbase,"/cgi-bin/fileio").openConnection();
		conn.setDoOutput(true);
		PrintStream Out= new PrintStream(conn.getOutputStream());
		Out.println("filename="+URLEncoder.encode(name) + "&get=");
		d = new DataInputStream(conn.getInputStream());
		return d;
		}




	public static boolean save_file(java.net.URL docbase, String name,
		String content) {
		DataInputStream d = null;
		boolean result = false;
		try {
		URLConnection conn = new URL(docbase,"/cgi-bin/fileio").openConnection();
		conn.setDoOutput(true);
		PrintStream Out= new PrintStream(conn.getOutputStream());
		Out.print("filename="+URLEncoder.encode(name) + "&put=");
		Out.println(URLEncoder.encode(content));
		d = new DataInputStream(conn.getInputStream());

		String s = d.readLine();
		if (s == null)
			throw new IOException(" no first line back ");

		if (s.substring(0,3).compareTo("ok ") != 0)
			{
			System.out.println("remote_file_io.save_file bad first line:"
				+s+":");
			throw new IOException(" didn't get ok ");
			}
		result=true;
		} catch (Exception e) {
		System.out.println("exception in remote_file_io.save_file: "
			+ e.toString());
		}
System.out.println("remote_file_io.save_file returning");
		if (d != null)
			try {
				d.close();
			} catch (Exception e) {
				// like I care if you can't close it.
			}
		return result;
	}

}
