/*
        Copyright(C) 1997 Network Flight Recorder, Inc.
        All rights reserved.

        Use and distribution of this software and its source code
        are governed by the terms and conditions of the
        Network Flight Recorder Software License ("LICENSE.TXT")

By Mark Sienkiewicz / NFR

*/


package nfr.misc;

import java.net.*;
import java.io.*;
import java.util.*;

public class type_mapping extends Object {
	static boolean initialized = false;

	static public ordered_table recordable;
	static public ordered_table primary_type;
	static public ordered_table secondary_type;
	static public ordered_table representation;

	public type_mapping(java.net.URL docbase) {
		if (! initialized)
			do_real_work(docbase);
	}

	static synchronized void do_real_work(java.net.URL docbase) {
		recordable = new ordered_table();
		primary_type = new ordered_table();
		secondary_type = new ordered_table();
		representation = new ordered_table();
		try {
		DataInputStream d = cgi_post.post( docbase, "fileio",
			"filename=etc/type-mapping.map&get=");
		for (;;)
			{
			String s = d.readLine();
			if (s == null)
				break;
			if (s.substring(0,0).compareTo("#") == 0)
				continue;
			StringTokenizer t=  new StringTokenizer(s);
			int n = t.countTokens();
			if (n != 4)
				continue;
			String n_recordable = t.nextToken();
			String n_primary_type = t.nextToken();
			String n_secondary_type = t.nextToken();
			String n_representation = t.nextToken();
			if (n_recordable.compareTo("*") != 0)
				recordable.put(n_recordable,n_primary_type);
			primary_type.put(n_primary_type,n_secondary_type);
			secondary_type.put(n_secondary_type,n_representation);
			representation.put(n_representation,"");
			}
		d.close();
		} catch (IOException e) {
		System.out.println("IO exception loading type_mapping: " + e.toString());
		}
		initialized = true;
	}

}

