/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   AlertSrcConfigurator.java
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

package nfr.rc;

import nfr.misc.*;
import java.awt.*;


public class AlertSrcConfigurator extends ResConfigurator
{
  TextField mName = null;
  TextField mDesc = null;

public AlertSrcConfigurator(ResId rid, ResTab rt)
  {
    super(rt);

    repTile l = new repTile();
    setLayout(l);

    Label lbl = new Label("Alert source name");
    add(lbl);
    l.setConstraints(0,0,0,0, "", lbl);
    mName = new TextField( ((AlertSrcRes)rid).getName() );
    add(mName);
    l.setConstraints(1,0,1,0, "", mName);

    lbl = new Label("Alert source description");
    add(lbl);
    l.setConstraints(2,0,2,0, "", lbl);
    mDesc = new TextField( ((AlertSrcRes)rid).getDesc() );
    add(mDesc);
    l.setConstraints(3,0,3,0, "", mDesc);
    l.setStretchy(-1,0);
  }

public boolean read(ResId rid)
  {
    mName.setText( ((AlertSrcRes)rid).getName() );
    mDesc.setText( ((AlertSrcRes)rid).getDesc() );

    return true;
  }

public boolean write(ResId rid)
  {
    String name = mName.getText();
    String errMsg = checkQuotes(name);
    if(errMsg != null)
      {
	MsgBox.show("Error", errMsg);
	return false;
      }
    String desc = mDesc.getText();
    errMsg = checkQuotes(desc);
    if(errMsg != null)
      {
	MsgBox.show("Error", errMsg);
	return false;
      }

    ((AlertSrcRes)rid).setName(name);
    ((AlertSrcRes)rid).setDesc(desc);
    return true;
  }

public void setEnabled(boolean b)
  {
    mName.enable(b);
    mDesc.enable(b);
  }

public void clear()
  {
    mName.setText("");
    mName.setText("");
  }

}
