/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   AlertSrcRes.java
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

package nfr.rc;

import java.net.*;
import java.io.*;
import java.awt.*;


public class AlertSrcRes extends ResId
{
  String mName = null;
  String mDesc = null;

public AlertSrcRes(ResTab rt)
  {
    super(rt);
    setType(RES_ALERT_SRC);
  }

public AlertSrcRes(int rc, DataInputStream In, ResTab rt)
  {
    super(rc, In, rt);
    try
      {
	int i = 0;
	int len = In.readInt();
	char sbuf[] = new char[len];
	while(i < len)
	  sbuf[i++] = (char) In.readByte();
	mName = new String(sbuf);

	i = 0;
	len = In.readInt();
	sbuf = new char[len];
	while(i < len)
	  sbuf[i++] = (char) In.readByte();
	mDesc = new String(sbuf);
      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
  }
  
public final String getName() { return mName; }

public void setName(String t) 
  { 
    if((mName != null) && (mName.equals(t)))
      return;
    
    mName = new String(t); 
    if(mState == RESID_STATE_STABLE)
      mState = RESID_STATE_ALTERED;
  }

public final String getDesc() { return mDesc; }

public void setDesc(String t) 
  { 
    if((mDesc != null) && (mDesc.equals(t)))
      return;

    mDesc = new String(t); 
    if(mState == RESID_STATE_STABLE)
      mState = RESID_STATE_ALTERED;
  }


public ResConfigurator getConfigurator(ResTab rt)
  {
    return new AlertSrcConfigurator(this, rt);
  }

public ResConfigurator getConfigurator()
  {
    return new AlertSrcConfigurator(this, mResTab);
  }

public boolean dump(DataOutputStream Out)
  {
    super.dump(Out);

    try
      {
	if(mName == null)
	  Out.writeInt(0);
	else
	  {
	    Out.writeInt(mName.length());
	    Out.writeBytes(mName);
	  }

	if(mDesc == null)
	  Out.writeInt(0);
	else
	  {
	    Out.writeInt(mDesc.length());
	    Out.writeBytes(mDesc);
	  }
      }	
    catch(Exception e)
      {
	e.printStackTrace();
	return false;
      }
    return true;
  }
  
}
