/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   FacId.java
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

package nfr.rc;

import java.net.*;
import java.io.*;
import java.awt.*;


/*****************************************************************************
*****************************************************************************/

public class FacId extends ResId
{
  String mGuiType = null;
  
public FacId(FacId id, ResTab rt)
  {
    super((ResId)id, rt);
    String guiType = id.getGuiType();
    if(guiType != null)
      setGuiType(guiType);
  }

public FacId(ResTab rt)
  {
    super(rt);
    setType(ID_FAC);
  }

public FacId(String Id, String DispName,  ResTab rt)
  {
    super(Id, DispName, rt);
    setType(ID_FAC);
  }

public FacId(int rc, DataInputStream In, ResTab rt)
  {
    super(rc, In, rt);
  }

public String toString()
  {
    return new String(super.toString() + ", mGuiType=" + mGuiType);
  }

public ResConfigurator getConfigurator(ResTab rt)
  {
    return new FacIdConfigurator(this, rt);
  }

public ResConfigurator getConfigurator()
  {
    return new FacIdConfigurator(this, mResTab);
  }

public void setGuiType(String type)
  {
    if(type != null)
      mGuiType = new String(type); 
  }

public String getGuiType()
  {
    if(mGuiType != null)
      return new String(mGuiType); 
    return null;
  }
}
