/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   RangeCfgStack.java
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

package nfr.rc;

import java.awt.*;

import nfr.misc.*;
import nfr.facilities.*;

public class RangeCfgStack extends Panel
{
  RangeConfigurator[] mRangeCfgs;
  int mRangeCount = 0;
  Choice mRangeChooser = null;
  Panel mRangePanel = null;
  repTile mLayout = null;

public RangeCfgStack(int size)
  {
    mLayout = new repTile();
    setLayout(mLayout);

    mRangeCfgs = new RangeConfigurator[size];
    mRangeChooser = new Choice();
    mRangeChooser.setBackground(Color.white);
    mRangePanel = new Panel();
    mRangePanel.setLayout(new CardLayout());
  }

public void build()
  {
    int row = 0;

    if(mRangeCount > 1)
      {
	add(mRangeChooser);
	mLayout.setConstraints(row,0,row,0,"", mRangeChooser);
	row++;
      }

    add(mRangePanel);
    mLayout.setConstraints(row,0,row,0,"", mRangePanel);

    mLayout.setborder(CtoP.Width(3,this), CtoP.Width(3,this),
		      CtoP.Height(1, this), CtoP.Height(1, this));

    mLayout.setStretchy(row,0);
  }

public boolean addRangeCfg(RangeConfigurator r, String dname)
  {
    if (mRangeCount >= mRangeCfgs.length)
      {
	System.out.println("RangeCfgStack overflow");
	return false;
      }

    mRangeChooser.addItem(dname);

    mRangeCfgs[mRangeCount] = r;
    mRangePanel.add(dname, r);

    mRangeCount++;
    return true;
  }

public boolean action(Event e, Object arg)
  {
    if (e.target == mRangeChooser)
      {
	// move the selected view to the front
	((CardLayout)mRangePanel.getLayout()).show(mRangePanel,(String)arg);
	return true;
      }

    return false;
  }

}
