/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   RangeRes.java
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

package nfr.rc;

import nfr.misc.*;

import java.util.*;
import java.net.*;
import java.io.*;
import java.awt.*;


public class RangeRes extends ResId
{
  int mMin = 0;
  int mMax = 0;
  int mMemberType = 0;
  int mHighNo = 0;
  RangeConfigurator mConfigurator = null;
public Vector Members = null;
  

public RangeRes(int rc, DataInputStream In, ResTab rt)
  {
    super(rc, In, rt);
    try
      {
	mMin = In.readInt();
	mMax = In.readInt();
	mMemberType = In.readInt();
	mHighNo = In.readInt();
      }
    catch(Exception e)
      {
	e.printStackTrace();
      }

    Members = new Vector();
  }

// accessors
public final int getMin() { return mMin; }
public final int getMax() { return mMax; }
public final int getMemberType() { return mMemberType; }
public final int getHighNo() { return mHighNo; }

public ResConfigurator getConfigurator()
  {
    return mConfigurator;
  }

public ResConfigurator getConfigurator(ResTab rt)
  {
    if (mConfigurator == null)
      mConfigurator = new RangeConfigurator(this, rt);
    return mConfigurator;
  }

public void insert(ResId rid)
  {
    Members.addElement(rid);
    mResTab.insert(rid);
    if(rid.getType() != ID_FAC)
      rid.setResNo(mMin);
  }

public boolean dump(DataOutputStream Out)
  {
    super.dump(Out); 

    try
      {
	Out.writeInt(mMin);
	Out.writeInt(mMax);
	Out.writeInt(mMemberType);
	Out.writeInt(mHighNo);
      }	
    catch(Exception e)
      {
	e.printStackTrace();
	return false;
      }
    return true;
  }
  
}
