/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   ResCode.java
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

package nfr.rc;

public class ResCode implements ResConsts
{
  int mCode = 0;

public ResCode()
  {
    mCode = 0;
  }

public ResCode(int rc)
  {
    mCode = rc;
  }


public final boolean isUser() 
  {
    int bit21 = ( (mCode >> 21) & 0x00000001);
    return ( bit21 != 0 ); 
  }

public final void setUser(boolean v) 
  { 
    if(v)
      mCode = mCode | (0x00000001 << 21);
    else
      mCode = mCode & (~(0x00000001 << 21));
  }

public final int getCode()
  { return mCode; }

public final int getResNo()
  { return (mCode & 0x0000FFFF); }

public final int getType()
  { return ((mCode >> 16) & 0x0000001F); }


public void setResNo(int n)
  {
    // System.out.println("trying to set resno to " + n);
    mCode = mCode & (~0x0000FFFF);
    mCode = mCode | (n & 0x0000FFFF);
    // System.out.println("now code is " + mCode);
  }


  // protected methods
protected void setType(int t)
  {
    // System.out.println("trying to set type to " + t);
    mCode = mCode & (~(0x0000003F << 16));
    mCode = mCode | ((t << 16) & (0x0000003F << 16) );
    // System.out.println("now code is " + mCode);
  }

}
