/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   ResIdConfigurator.java
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

package nfr.rc;

import nfr.misc.*;
import java.awt.*;


public class ResIdConfigurator extends ResConfigurator
{
  Label mIdLabel = null;

public ResIdConfigurator(ResId rid, ResTab rt)
  {
    super(rt);
    
    String s = rid.getId();
    if (s == null)
      s = new String("<empty>");
    mIdLabel = new Label(s);
    add(mIdLabel);
  }

public boolean read(ResId rid)
  {
    if(mIdLabel == null)
      {
	mIdLabel = new Label(rid.getId());
	add(mIdLabel);
      }
    else
      mIdLabel.setText(rid.getId());
    return true;
  }

public boolean write(ResId rid)
  {
    return true;
  }

public void setEnabled(boolean b)
  {
    mIdLabel.enable(b);
  }

public void clear()
  {
    mIdLabel.setText("");
  }

}
