/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   StringConfigurator.java
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

package nfr.rc;

import nfr.misc.*;
import java.awt.*;

/*****************************************************************************
*****************************************************************************/

public class StringConfigurator extends ResConfigurator
{
  TextField mStringVal = null;

public StringConfigurator(ResId rid, ResTab rt)
  {
    super(rt);

    repTile l = new repTile();
    setLayout(l);

    Label lbl = new Label("String value");
    add(lbl);
    l.setConstraints(0,0,0,0, "", lbl);
    mStringVal = new TextField( ((StringRes)rid).getString() );
    add(mStringVal);
    l.setConstraints(1,0,1,0, "", mStringVal);
    l.setStretchy(-1,0);
  }

public boolean read(ResId rid)
  {
    mStringVal.setText( ((StringRes)rid).getString() );
    return true;
  }

public boolean write(ResId rid)
  {
    ((StringRes)rid).setString(mStringVal.getText());
    return true;
  }

public void setEnabled(boolean b)
  {
    mStringVal.enable(b);
  }

public void clear()
  {
    mStringVal.setText("");
  }

}
