/*****************************************************************************
  Copyright(C) 1996, 1997 Network Flight Recorder, Inc.
  All rights reserved.

  Use and distribution of this software and its source code
  are governed by the terms and conditions of the
  Network Flight Recorder Software License ("LICENSE.TXT")


  File:   StringRes.java
  Author: Andrew Lambeth <andrew@nfr.net>

 *****************************************************************************/

package nfr.rc;

import java.net.*;
import java.io.*;
import java.awt.*;


/*****************************************************************************
*****************************************************************************/

public class StringRes extends ResId
{
  String mString = null;

public StringRes(ResTab rt)
  {
    super(rt);
    setType(RES_STRING);
  }

public StringRes(int rc, DataInputStream In, ResTab rt)
  {
    super(rc, In, rt);
    try
      {
	int i = 0;
	int len = In.readInt();
	char sbuf[] = new char[len];
	while(i < len)
	  sbuf[i++] = (char) In.readByte();
	mString = new String(sbuf);
      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
  }
  
public final String getString() { return mString; }

public final void setString(String s) 
  { 
    if((mString != null) && (mString.equals(s)))
      return;

    mString = new String(s); 
    if(mState == RESID_STATE_STABLE)
      mState = RESID_STATE_ALTERED;
  }

public ResConfigurator getConfigurator(ResTab rt)
  {
    return new StringConfigurator(this, rt);
  }

public ResConfigurator getConfigurator()
  {
    return new StringConfigurator(this, mResTab);
  }

public boolean dump(DataOutputStream Out)
  {
    super.dump(Out);
    try
      {
	if(mString == null)
	  Out.writeInt(0);
	else
	  {
	    Out.writeInt(mString.length());
	    Out.writeBytes(mString);
	  }
      }	
    catch(Exception e)
      {
	e.printStackTrace();
	return false;
      }
    return true;
  }
  
}
