/*
        Copyright(C) 1997 Network Flight Recorder, Inc.
        All rights reserved.

        Use and distribution of this software and its source code
        are governed by the terms and conditions of the
        Network Flight Recorder Software License ("LICENSE.TXT")

By Mark Sienkiewicz / NFR

*/

import java.io.*;
import java.awt.*;
import nfr.misc.*;
import java.util.*;
import java.net.*;
import java.applet.*;
import nfr.rc.*;
import nfr.alerts.*;

public class toplevel extends Panel {

	//
	// this object is the top of the NFR GUI
	//

	//
	Font subtitlefont;
	Font titlefont;

	//
	// string table, for multi-language ability
static	Cf st = null;

        // Stuff for the packages tab
	PackagesPanel pkgPanel;

	Button alert_config_button;

	Button quit_button;

	extabthing tabbie;

public toplevel() 
	{

	NFRInfo.do_style(this);

		if (st == null)
			{
			st = new 
			Cf(NFRInfo.document_base,"etc/javastrings/toplevel");
			st.Read();
			}

//bug:		this.setTitle(st.textorname("NFR"));

	subtitlefont = NFRInfo.default_font;
	titlefont = subtitlefont;

	subtitlefont = new Font (subtitlefont.getName(), Font.BOLD, 
			subtitlefont.getSize()+2);
	
	titlefont = new Font (titlefont.getName(), Font.BOLD, 
			titlefont.getSize()+6);




	// make top of window

	Panel top_of_window = new Panel();

	{
	repTile w1 = new repTile();
	w1.setStretchy(0,0);
	top_of_window.setLayout(w1);
	NFRInfo.do_style(top_of_window);
	String s = (String) st.get("name1");
	if (s == null)
		s="Network Flight Recorder";
	Label l = new Label(s);
	top_of_window.add(l);
	w1.setConstraints(0,0,0,0,"ch",l);
	/***
	s = (String) st.get("name2");
	if (s != null)
		{
		l=new Label(s);
		top_of_window.add(l);
		w1.setConstraints(1,0,1,0,"ch",l);
		}
	****/
	}

	repTile w1 = new repTile();
	setLayout(w1);	// make this widget the top level of the applet

	tabbie = new extabthing(10);
	add(tabbie);
	w1.setConstraints(0,0,0,0,"",tabbie);
	w1.setStretchy(0,0);


	quit_button = new Button(st.textorname("exit"));

	quit_button.setForeground(Color.black);
	quit_button.setBackground(Color.white);

	NFRInfo.dancyThing = new BarMeter(false, Meter.FIXED_MAX);
    	NFRInfo.dancyThing.set_size(new Dimension(CtoP.Width(19,this),
					 CtoP.Height(1,this)));
	NFRInfo.dancyThing.set_foreground(Color.red);
	NFRInfo.dancyThing.set_background(Color.black);
	//NFRInfo.dancyThing.update();
	


	tabbie.set_common_things(
		new jafp( NFRInfo.ThisApplet, "/images/gui_logo.gif"),
		 // new Label("dancy bar thing"),
			NFRInfo.dancyThing,
			quit_button, top_of_window );

	// eye candy used to be here.  not any more, pending the
	// improved version being ready

	// a card -

	{
	// New Package Tab
	pkgPanel = new PackagesPanel();
	tabbie.addThing(pkgPanel, new jafp(NFRInfo.ThisApplet,
			"/images/packages.gif"));
	}

	// a card -
	{
	Panel q = new Panel();
	// w3=new repTile();
	// q.setLayout(w3);
	alert_config_button = 
	  new Button(st.textorname("alert_config"));
	q.add(alert_config_button);

	tabbie.addThing(q,new jafp(NFRInfo.ThisApplet, 
			"/images/configure.gif"));
	}

	// a card - 
	{
	AlertViewer av = new AlertViewer();
	tabbie.addThing(av,new jafp(NFRInfo.ThisApplet, 
			"/images/alert.gif"));
	}


	// do this after you are done adding to the tab
	tabbie.compute();


	setFont(NFRInfo.font);
	// resize(CtoP.Width(90,this), CtoP.Height(28,this));
	show();

	}

/****
* no special paint instructions yet.
*/
        public void paint(Graphics gc) {
                // System.out.println("in paint function");
	}

/****
* all events come here
*/
	public boolean action(Event e, Object o) {
		if (e.target == alert_config_button)
		  {
		    ResTab nfrRt = new ResTab();
		    nfrRt.load(NFRInfo.document_base, 
			       NFRInfo.nfr_resource_file_name);

		    ResTab usrRt = new ResTab();
		    usrRt.load(NFRInfo.document_base, 
			       NFRInfo.usr_resource_file_name);

		    ResTabCfgWindow cfgWindow = 
		      new ResTabCfgWindow(nfrRt, usrRt, NFRInfo.top);
		    NFRInfo.do_style(cfgWindow);
		    cfgWindow.show();

		    return true;
		  }

		if (e.target == quit_button)
		  {
		    NFRInfo.top.dispose();
		    NFRInfo.top = null;
		    return true;
		  }

		return false;
	}

        //
        // This is UNBELIEVABLY STUPID, but essential.
        // AWT doesn't seem to be able to handle resizes properly, so
        // we do an end-run around it and do it ourselves.  If you
        // don't, the window correctly gets bigger, but not smaller.
        // i.e. if you resize the window to be some size smaller than
        // the largest it has ever been, then the components in the
        // window are told that the window is still that large.
        //
        // The sequence here comes from trial-and-error, not any particular
        // understanding of how AWT is malfunctioning.  If you touch it,
        // be prepared for it to break.
        // 
        public void reshape(int x, int y , int w, int h)
        {
        super.reshape(x,y,w,h);
        resize(w,h);
        }
 
        boolean break_recursion = false;
 
        public void resize ( int w, int h )
        {
        if (! break_recursion) 
                {
// System.out.println("\n\n\nMy size "+this.size());
if (getParent() == null)
	{
	System.out.println("toplevel: NO PARENT!\n");
	return;
	}
// System.out.println("Parent size "+getParent().size()+"\n\n\n");
                Dimension d = getParent().size();
                Insets i = getParent().insets();
// System.out.println("enter super.resize");
                break_recursion = true;
                super.resize(d.width - i.left - i.right , d.height -
                        i.top - i.bottom );
                break_recursion = false;
// System.out.println("leave super.resize");
                tabbie.reshape( 0, 0, d.width - i.left - i.right , d.height -
                        i.top - i.bottom );
// System.out.println("leave tt.resize");
//              try { Thread.sleep(3000); } catch (Exception e) { }
// System.out.println("done sleeping at higher level");
                }
        else
                System.out.println("breaking recursion");
        }

}

