/*
        Copyright(C) 1997 Network Flight Recorder, Inc.
        All rights reserved.

        Use and distribution of this software and its source code
        are governed by the terms and conditions of the
        Network Flight Recorder Software License ("LICENSE.TXT")

By Mark Sienkiewicz / NFR

*/

import java.io.*;
import java.awt.*;
import nfr.misc.*;
import java.util.*;
import java.net.*;
import graph.*;

class types_panel extends Panel {
	ordered_table label_textfield;

	public types_panel() {
		label_textfield = new ordered_table();
	}

	public void compute() {
		repTile r= new repTile();
		setLayout(r);
		r.setStretchy(-1,1);
		int x = 0;
		Enumeration e = label_textfield.keys();
		while (e.hasMoreElements())
			{
			String s = (String) e.nextElement();
			Label l = new Label(s);
			add(l);
			r.setConstraints(x,0,x,0,"",l);
			TextField t = new TextField();
			add(t);
			r.setConstraints(x,1,x,1,"",t);
			label_textfield.put(s,t);
			x = x + 1;
			}
	}

	public String build_url_frag(String prefix) {
		String rval = "";
		Enumeration e= label_textfield.keys();
		while (e.hasMoreElements())
			{
			String key = (String) e.nextElement();
			TextField t = (TextField) label_textfield.get(key);

			//
			// Below, the 'text' object will contain all
			// four of the strings I'm interested in at
			// some point during URL construction.
			//

			String text = t.getText();
			if (text.length() > 0)
				rval = rval + "&" +
					URLEncoder.encode(prefix+key)+ "=" +
					URLEncoder.encode(text);
			}
		return rval;
	}

	public void print(String title) {
		Enumeration e= label_textfield.keys();
		while (e.hasMoreElements())
			{
			String s = (String) e.nextElement();
			TextField t = (TextField) label_textfield
				.get(s);
			}
	}

  public Vector strings() {
    Vector vec = new Vector();
    Enumeration e = label_textfield.keys();
    while(e.hasMoreElements()) {
      String s = (String) e.nextElement();
      TextField t = (TextField) label_textfield.get(s);
      vec.addElement(t.getText());
    }
    return(vec);
  }

  public Vector fields() {
    Vector vec = new Vector();
    Enumeration e = label_textfield.keys();
    while(e.hasMoreElements()) {
      String s = (String) e.nextElement();
      TextField t = (TextField) label_textfield.get(s);
      vec.addElement(t);
    }
    return(vec);  
  }

}
